#include "stdafx.h"
#include "PortForwardEngine.h"

#include <iphlpapi.h>
#pragma comment ( lib, "iphlpapi" )
#include <shlwapi.h>
#pragma comment ( lib, "shlwapi" )

CPortForwardEngine PFE;

void
GetDeviceInformation()
{
	HWND temphwnd=FindWindow("PcHelpWare Control Viewer",NULL);
	PFE.GetDeviceInformationUsingThread( temphwnd );
}

BOOL
AnyThread()
{
	return PFE.IsAnyThreadRunning();
}

char *
Getinfo(char*model)
{
CPortForwardEngine::DeviceInformationContainer m_DeviceInfoContainer;
m_DeviceInfoContainer =  PFE.GetDeviceInformationContainer( );
strcpy(model,"");
if ( m_DeviceInfoContainer.Description.IsEmpty() != TRUE )  {strcat(model, m_DeviceInfoContainer.Description);strcat(model," -- ");}
if ( m_DeviceInfoContainer.ModelName.IsEmpty() != TRUE )  strcat(model, m_DeviceInfoContainer.ModelName);
			
  return model;
}

void Listenchanges()
{
PFE.ListenForUpnpChanges(NULL);
}

void StopListenChanges()
{
PFE.StopListeningForUpnpChanges();
}


CPortForwardEngine::PortMappingContainer newMapping;
void add_mapping( DWORD port)
{
CString strLocalIP;
	
	PIP_ADAPTER_INFO pAdapterInfo = NULL;
	DWORD dwRetVal = 0;
	
	pAdapterInfo = (IP_ADAPTER_INFO *) malloc( sizeof(IP_ADAPTER_INFO) );
	ULONG ulOutBufLen = sizeof(IP_ADAPTER_INFO);
	
	// Make an initial call to GetAdaptersInfo to get
	// the necessary size into the ulOutBufLen variable
	
	if (GetAdaptersInfo( pAdapterInfo, &ulOutBufLen) == ERROR_BUFFER_OVERFLOW) 
	{
		free(pAdapterInfo);
		pAdapterInfo = (IP_ADAPTER_INFO *) malloc (ulOutBufLen); 
	}
	
	if ((dwRetVal = GetAdaptersInfo( pAdapterInfo, &ulOutBufLen)) == NO_ERROR)
	{
		strLocalIP = CString( (LPCSTR)(pAdapterInfo->IpAddressList.IpAddress.String) );  // note: not LPCTSTR
	}
	else 
	{
		strLocalIP.Empty();
	}
	
	free(pAdapterInfo);
		
	newMapping.ExternalPort.Format( _T("%d"), port );
	newMapping.Protocol = ( _T("TCP"));
	newMapping.InternalClient = strLocalIP;
	newMapping.InternalPort.Format( _T("%d"), port );
	newMapping.Enabled = (_T("Yes"));
	newMapping.Description = (_T("PcHelpWare"));
	HWND temphwnd=FindWindow("PcHelpWare Control Viewer",NULL);
		
	if ( PFE.AddMappingUsingThread( newMapping, temphwnd ) != FALSE )
		{

		}
		else
		{
			::MessageBox(temphwnd, _T("Le moteur de mappage des ports est occup \n")
				_T("Veuillez essayer  nouveau dans quelques secondes"), 
				_T("Occup"), MB_OK|MB_ICONEXCLAMATION );
		}


}

void remove_mapping()
{
	
		HWND temphwnd=FindWindow("PcHelpWare Control Viewer",NULL);
		if (PFE.DeleteMappingUsingThread( newMapping, temphwnd) != FALSE )
		{

		}
		else
		{
			::MessageBox( temphwnd, _T("Le moteur de mappage des ports est occup \n")
				_T("Veuillez essayer  nouveau dans quelques secondes"), 
				_T("Occup"), MB_OK|MB_ICONEXCLAMATION );
		}
}