#include	<stdio.h>
#include	<windows.h>
#include	<winsock.h>
#include	<process.h>
#include    <stdlib.h>
#include	<tchar.h>
#include "../resource.h"

#ifdef __cplusplus
extern "C" {
int mainconnect( int argc, char **argv );
char * readpass( const char* prompt, ...);
}
#endif

//#define SSLCLIENT
#define HTTP_PORT 80
#define HTTPS_PORT 443
#define MAX_HOST_NAME_LEN 256
//#define SSLSERVER
HKEY hkLocal1=NULL;
bool regblocked;
TCHAR REGISTRY_KEY [] = "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings";
char viewerhost[150];
char viewerproxyhost[150];
TCHAR remotehost3[256];
int remoteport3=0;
extern HWND main_window;


void
OpenRegistry1()
{
	regblocked=true;
	DWORD dw;
	hkLocal1=NULL;
	
	if (RegCreateKeyEx(HKEY_CURRENT_USER,
		REGISTRY_KEY,
		0,REG_NONE, REG_OPTION_NON_VOLATILE,
		KEY_READ,
		NULL, &hkLocal1, &dw) != ERROR_SUCCESS)

		return;

}

void
CloseRegistry1()
{
	if (hkLocal1 != NULL) RegCloseKey(hkLocal1);
	regblocked=false;
}

TCHAR *
LoadString1(HKEY key, LPCSTR keyname)
{
	DWORD type = REG_SZ;
	DWORD buflen = 256*sizeof(TCHAR);
	TCHAR *buffer = 0;

	// Get the length of the string
	if (RegQueryValueEx(key,
		keyname,
		NULL,
		&type,
		NULL,
		&buflen) != ERROR_SUCCESS)
		return 0;

	if (type != REG_SZ)
		return 0;
	buflen = 256*sizeof(TCHAR);
	buffer = new TCHAR[buflen];
	if (buffer == 0)
		return 0;

	// Get the string data
	if (RegQueryValueEx(key,
		keyname,
		NULL,
		&type,
		(BYTE*)buffer,
		&buflen) != ERROR_SUCCESS) {
		delete [] buffer;
		return 0;
	}

	// Verify the type
	if (type != REG_SZ) {
		delete [] buffer;
		return 0;
	}

	return (TCHAR *)buffer;
}
LONG
LoadInt(HKEY key, LPCSTR valname, LONG defval)
{
	LONG pref;
	ULONG type = REG_DWORD;
	ULONG prefsize = sizeof(pref);

	if (RegQueryValueEx(key,
		valname,
		NULL,
		&type,
		(LPBYTE) &pref,
		&prefsize) != ERROR_SUCCESS)
		return defval;

	if (type != REG_DWORD)
		return defval;

	if (prefsize != sizeof(pref))
		return defval;

	return pref;
}
TCHAR*
Readsettings()
{
	TCHAR *value=NULL;
	OpenRegistry1();
	if (hkLocal1) value=LoadString1 (hkLocal1, "ProxyServer");
	CloseRegistry1();
	return value;
}

LONG
Readproxy(LONG returnvalue)
{
	OpenRegistry1();
	if (hkLocal1) returnvalue=LoadInt(hkLocal1, "ProxyEnable",returnvalue);
	CloseRegistry1();
	return returnvalue;
}

BOOL ParseDisplay(LPTSTR display, LPTSTR phost, int hostlen, int *pport) 
{
	int tmp_port;
	TCHAR *colonpos = _tcschr(display, L':');
    if (hostlen < (int)_tcslen(display))
        return FALSE;

    if (colonpos == NULL)
	{
		// No colon -- use default port number
        tmp_port = HTTP_PORT;
		_tcsncpy(phost, display, MAX_HOST_NAME_LEN);
	}
	else
	{
		_tcsncpy(phost, display, colonpos - display);
		phost[colonpos - display] = L'\0';
		if (colonpos[1] == L':') {
			// Two colons -- interpret as a port number
			if (_stscanf(colonpos + 2, TEXT("%d"), &tmp_port) != 1) 
				return FALSE;
		}
		else
		{
			// One colon -- interpret as a display number or port number
			if (_stscanf(colonpos + 1, TEXT("%d"), &tmp_port) != 1) 
				return FALSE;

			// RealVNC method - If port < 100 interpret as display number else as Port number
			if (tmp_port < 100)
				tmp_port += HTTP_PORT;
		}
	}
    *pport = tmp_port;
    return TRUE;
}

BOOL ParseDisplay2(LPTSTR display, LPTSTR phost, int hostlen, int *pport) 
{
	int tmp_port;
	TCHAR *colonpos = _tcschr(display, L':');
    if (hostlen < (int)_tcslen(display))
        return FALSE;

    if (colonpos == NULL)
	{
		// No colon -- use default port number
        tmp_port = HTTPS_PORT;
		_tcsncpy(phost, display, MAX_HOST_NAME_LEN);
	}
	else
	{
		_tcsncpy(phost, display, colonpos - display);
		phost[colonpos - display] = L'\0';
		if (colonpos[1] == L':') {
			// Two colons -- interpret as a port number
			if (_stscanf(colonpos + 2, TEXT("%d"), &tmp_port) != 1) 
				return FALSE;
		}
		else
		{
			// One colon -- interpret as a display number or port number
			if (_stscanf(colonpos + 1, TEXT("%d"), &tmp_port) != 1) 
				return FALSE;

			// RealVNC method - If port < 100 interpret as display number else as Port number
			if (tmp_port < 100)
				tmp_port += HTTPS_PORT;
		}
	}
    *pport = tmp_port;
    return TRUE;
}

void
Readhelpdesk()
{
	FILE *fid;
	bool done=false;
	char menustrings[1024];
	if (GetModuleFileName(NULL, menustrings, 1024))
					{
						char* p = strrchr(menustrings, '\\');
						if (p == NULL) return;
						*p = '\0';
						strcat (menustrings,"\\helpdesk.txt");
					}
	
	int i=0;
	bool direct=false;
	if ((fid = fopen(menustrings, "r"))!=NULL)
	{
		char myline[150];
		while( fgets( myline, sizeof(myline), fid ))
			{				
				if (strncmp(myline, "[SSLHOST]", strlen("[SSLHOST]")) == 0) {
				//fgets( myline, sizeof(myline), fid );
				fgets( myline, sizeof(myline), fid );
				strcpy(viewerhost,"");
				strcpy(viewerhost,myline);
					}
				if (strncmp(myline, "[SSLPROXYHOST]", strlen("[SSLPROXYHOST]")) == 0) {
				//fgets( myline, sizeof(myline), fid );
				fgets( myline, sizeof(myline), fid );
				strcpy(viewerproxyhost,"");
				strcpy(viewerproxyhost,myline);
					}
					
			}
		fclose(fid);
	}				
}



int Get_https_socket(char *port, char *host)
{
	TCHAR *proxy=Readsettings();
	if (proxy==NULL) return 0;
	long ProxyEnable=0;
	ProxyEnable=Readproxy(ProxyEnable);
	TCHAR remotehost[256];
	int remoteport=0;
	TCHAR remotehost2[256];
	int remoteport2=0;
	TCHAR remotehost4[256];
	int remoteport4=0;
	Readhelpdesk();

	TCHAR * pch;
	TCHAR * pch2;
	TCHAR tempchar1[256];
	TCHAR tempchar2[256];
	TCHAR tempchar3[256];
	TCHAR tempchar4[256];
	_tcscpy(tempchar1,"");
	_tcscpy(tempchar2,"");
	pch = _tcstok (proxy,";");

	
	if (_tcsstr(pch,"http=")!=NULL)
	{
		_tcscpy(tempchar1,pch);
	}
	if (_tcsstr(pch,"https=")!=NULL)
	{
		_tcscpy(tempchar2,pch);
	}
	if (_tcsstr(pch,"=")==NULL)
	{
		_tcscpy(tempchar2,pch);
	}

	while (pch != NULL)
		{
			pch = _tcstok (NULL, ";");
			if (pch != NULL)
			{
				if (_tcsstr(pch,"http=")!=NULL)
					{
						_tcscpy(tempchar1,pch+5);
					}
				if (_tcsstr(pch,"https=")!=NULL)
					{
						_tcscpy(tempchar2,pch+6);
					}

			}
	}
	ParseDisplay(tempchar1, remotehost, 255, &remoteport);
	ParseDisplay2(tempchar2, remotehost2, 255, &remoteport2);
	SOCKET mysock=0;

	char text[100];
	if (ProxyEnable)
	{ 
		strcpy(text,"Proxy activ: ");
		SendMessage (GetDlgItem(main_window, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)text);
		strcpy(text,tempchar2);
		SendMessage (GetDlgItem(main_window, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)text);
	}
	else
	{
		strcpy(text,"Proxy dsactiv : ");
		SendMessage (GetDlgItem(main_window, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)text);
		strcpy(text,tempchar2);
		SendMessage (GetDlgItem(main_window, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)text);
		SendMessage (GetDlgItem(main_window, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Test cont, mais phw"); 
		SendMessage (GetDlgItem(main_window, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"n'utilisera pas un proxy dsactiv.");
	}



	char *arguments[] = {"preconnect","-d","-p","1111","-H",tempchar2,host,port};
	char *arguments2[] = {"preconnect","-d","-p","1111","-S",tempchar2,host,port};
		if (remoteport2!=1080)
		{
			SendMessage (GetDlgItem(main_window, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Utilisation de la mthode connect"); 
			mysock=mainconnect(8,arguments);
		}
		else
		{
			SendMessage (GetDlgItem(main_window, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Proxy socks"); 
			mysock=mainconnect(8,arguments2);
		}

	return mysock;
}
