// natconnect.cpp : Defines the entry point for the application.
//

#include <winsock2.h>
#include <windows.h>
#include "resource.h"
#include "pchelpware.h"
#include "CryptoService.h"
#include "md5.h"

#include <stdio.h>
#include <stdlib.h>
#include <commctrl.h>

HINSTANCE g_hinst;
HWND main_window;

bool G_RADIO=false;
bool G_DYNALIAS=false;
bool G_PROXY=false;

bool G_HIGH=true;
bool G_MID=false;
bool G_LOW=false;

bool G_DEBUG=false;
bool G_AUTOCON=false;
bool G_UPN=true;
bool G_DIRECTX=true;
bool upnp_map=false;
bool upnp_unmap=false;

///upnp
void GetDeviceInformation();
char *Getinfo(char* model);
BOOL AnyThread();
void add_mapping( DWORD port);
void remove_mapping();
//dll
//void Start_viewer(char *ID, char *repeater,unsigned int listenport,unsigned int repport,char *passwd,bool debug,bool proxy_bool,char bandwidth,bool use_directx);
//dynaias
int Set_dynamic_host(char *myhost, char *address, unsigned int port);
int Get_dynamic_host(char *myhost, char *address, unsigned int port,char *viewer_ip);
int Test_remote_port(char *address, int port);
int Get_https_socket(char *port, char *host);


//GLOBAL settings used to autoreconnect
char G_hostname[100];
char G_repID[10];
char G_listenport[10];
char G_viewerport[10];
char G_password[100];
bool G_debug;
bool G_http;
int G_bandwidth=1;
bool G_upnp;
bool G_use_directx=false;

///dll import
typedef void (/*__declspec(dllimport)*/ * Start_viewer_fn)(char *,char *,int,int,char *,bool,bool,char,bool);
Start_viewer_fn Start_viewer=NULL;
HMODULE hDLL=NULL;

bool
ImportDLL_functions()
{
	hDLL = LoadLibrary ("1SCVDLL.dll");
	if (!hDLL) return 0;
	Start_viewer = (Start_viewer_fn) GetProcAddress(hDLL,"Start_viewer");
	if (!Start_viewer)
	{	
		// handle the error
		FreeLibrary(hDLL);
		return 0;		   
	}
	return 1;
}

void
Free_DLL_functions()
{
	if (hDLL)
		FreeLibrary(hDLL);
}


int Copy_to_custom()
{
char mypath[1024];
char from[1024];
char to[1024];
if (GetModuleFileName(NULL, mypath, 1024))
	{
		char* p = strrchr(mypath, '\\');
		if (p == NULL) return 0;
		*p = '\0';
	}


SHFILEOPSTRUCT fop;

ZeroMemory(to, 1024);
ZeroMemory(from, 1024);
strcpy(from,mypath);
strcpy(to, mypath);
strcat(from,"\\server_res\\background.bmp");
strcat(to,"\\create_server\\custom\\background.bmp");
fop.hwnd = NULL; 
fop.wFunc = FO_COPY; 
fop.pFrom = from; 
fop.pTo = to;
fop.fFlags = FOF_ALLOWUNDO;
SHFileOperation(&fop); 

ZeroMemory(to, 1024);
ZeroMemory(from, 1024);
strcpy(from,mypath);
strcpy(to, mypath);
strcat(from,"\\server_res\\icon1.ico");
strcat(to,"\\create_server\\custom\\icon1.ico");
fop.hwnd = NULL; 
fop.wFunc = FO_COPY; 
fop.pFrom = from; 
fop.pTo = to;
fop.fFlags = FOF_ALLOWUNDO;
SHFileOperation(&fop);

ZeroMemory(to, 1024);
ZeroMemory(from, 1024);
strcpy(from,mypath);
strcpy(to, mypath);
strcat(from,"\\server_res\\helpdesk.txt");
strcat(to,"\\create_server\\custom\\helpdesk.txt");
fop.hwnd = NULL; 
fop.wFunc = FO_COPY; 
fop.pFrom = from; 
fop.pTo = to;
fop.fFlags = FOF_ALLOWUNDO;
SHFileOperation(&fop);



return 1;
}
char G_VIEWER_NAME[100];


BOOL CALLBACK Dialog(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{  
 
    switch (message) 
    { 
        case WM_INITDIALOG: 
            SendDlgItemMessage(hwndDlg,IDC_EDIT1, WM_SETTEXT, 100, (LONG)G_VIEWER_NAME);
            return TRUE; 
 
        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
                    SendDlgItemMessage(hwndDlg,IDC_EDIT1, WM_GETTEXT, 100, (LONG)G_VIEWER_NAME);
					EndDialog(hwndDlg,0);
                    return TRUE;  
            } 
    } 
    return FALSE; 
} 

static char eol[] = "\n";

void create_server(HWND hWnd)
{
	char data1[150];
	char data10[150];
	ZeroMemory(data10,150);
	char hostname[100];
	char password[100];
	char portdynalias[10];
	char alias[100];
	char listenport[10];
	char viewerport[10];
	char repID[10];
	char viewer_ip[100];

	ZeroMemory(hostname,100);
	ZeroMemory(password,100);
	ZeroMemory(alias,100);
	ZeroMemory(portdynalias,10);
	ZeroMemory(listenport,10);
	ZeroMemory(viewerport,10);
	ZeroMemory(repID,10);

	char connect_line[250];
	ZeroMemory(connect_line,250);


	bool listen=false;
	bool repeater=false;
	bool dynalias=false;
	bool http=false;

	SendDlgItemMessage(hWnd,IDC_EDIT1, WM_GETTEXT, 150, (LONG)data1);
		if (strlen(data1)==0) 
			{
				MessageBox( hWnd,"Vous devez dfinir un alias","Paramtre invalide",MB_ICONWARNING);
				return;
			}
	SendDlgItemMessage(hWnd,IDC_EDIT10, WM_GETTEXT, 150, (LONG)data10);
	if (strlen(data10)==0) 
			{
				MessageBox( hWnd,"Le mot de passe doit tre indiqu.","Paramtre invalide",MB_ICONWARNING);
				return;
			}
	SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_RESETCONTENT, 0, (LPARAM)"");
							if (SendMessage(GetDlgItem(hWnd, IDC_RADIO1), BM_GETCHECK, 0, 0) == BST_CHECKED)
			{
				listen=true;
				repeater=false;
			}
	else
			{
				listen=false;
				repeater=true;
			}
	if (listen)
	{
		SendDlgItemMessage(hWnd,IDC_EDIT2, WM_GETTEXT, 10, (LONG)listenport);
			if (strlen(listenport)==0) 
					{
									MessageBox( hWnd,"Vous devez dfinir un port d'coute.","Paramtre invalide",MB_ICONWARNING);
									return ;
								}
			if (SendMessage(GetDlgItem(hWnd, IDC_CHECK1), BM_GETCHECK, 0, 0) == BST_CHECKED) dynalias=true;
			else dynalias=false;
			if (dynalias)
				{
						SendDlgItemMessage(hWnd,IDC_EDIT9, WM_GETTEXT, 150, (LONG)hostname);
						SendDlgItemMessage(hWnd,IDC_EDIT7, WM_GETTEXT, 10, (LONG)portdynalias);
						SendDlgItemMessage(hWnd,IDC_EDIT8, WM_GETTEXT, 150, (LONG)alias);
						if (strlen(hostname)==0)
							{
								MessageBox( hWnd,"Aucun rptiteur dfini.","Paramtre invalide",MB_ICONWARNING);
								return ;
							}
						if (strlen(portdynalias)==0)
							{
								MessageBox( hWnd,"Pas de port dyn dfini.","Paramtre invalide",MB_ICONWARNING);
								return ;
							}
						if (strlen(alias)==0)
							{
								MessageBox( hWnd,"Pas d'alias dyn dfini.","Paramtre invalide",MB_ICONWARNING);
								return ;
							}
				}
			else
				{
					if (!Set_dynamic_host(data1, "uvnc.com", 5912))
							{
								MessageBox( hWnd,"Echec de la mise en place de l'aliasdyn.","Erreur",MB_ICONWARNING);
								//return
							}
					if (!Get_dynamic_host(data1, "uvnc.com", 5912,viewer_ip))
							{
								MessageBox( hWnd,"La recherche de l'adresse IP externe a choue.","Erreur",MB_ICONWARNING);
								strcpy(G_VIEWER_NAME,"UNKNOWN");
							}
					strcpy(G_VIEWER_NAME,viewer_ip);
					DialogBoxParam(g_hinst, MAKEINTRESOURCE(IDD_DIALOG2), NULL, (DLGPROC)Dialog,(LPARAM)NULL);
					strcpy(viewer_ip,G_VIEWER_NAME);

					
				}
			if (dynalias)
			{
				int result=MessageBox( hWnd,"Est-ce que l'utilisateur devra entrer l'alias?","Alias",MB_YESNO);
				int result2=MessageBox( hWnd,"Est-ce que l'utilisateur devra entrer le mot de passe?","Mot de Passe",MB_YESNO);
				strcpy(connect_line, "-connect dyn:");
				strcat(connect_line,listenport);
				strcat(connect_line," -dynhost ");
				strcat(connect_line,hostname);
				strcat(connect_line,":");
				strcat(connect_line,portdynalias);
				strcat(connect_line," -dynname ");
				if (result==6) strcat(connect_line,"ask");
				else strcat(connect_line,alias);
				strcat(connect_line," -passwd ");
				cMD5 myMD5;
				char *test=myMD5.CalcMD5FromString(data10);

				if (result2==6) strcat(connect_line,"ask");
				else strcat(connect_line,test);


			}
			else
			{
				int result2=MessageBox( hWnd,"Est-ce que l'utilisateur devra entrer le mot de passe?","Mot de Passe",MB_YESNO);
				strcpy(connect_line, "-connect ");
				strcat(connect_line,viewer_ip);
				strcat(connect_line,":");
				strcat(connect_line,listenport);
				strcat(connect_line," -passwd ");
				cMD5 myMD5;
				char *test=myMD5.CalcMD5FromString(data10);

				if (result2==6) strcat(connect_line,"ask");
				else strcat(connect_line,test);
			}
	}//listen
	if (repeater)
	{
		SendDlgItemMessage(hWnd,IDC_EDIT9, WM_GETTEXT, 150, (LONG)hostname);
		SendDlgItemMessage(hWnd,IDC_EDIT5, WM_GETTEXT, 10, (LONG)viewerport);
		SendDlgItemMessage(hWnd,IDC_EDIT3, WM_GETTEXT, 10, (LONG)repID);
		if (SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_GETCHECK, 0, 0) == BST_CHECKED) http=true;
			else http=false;
		if (strlen(hostname)==0)
			{
					MessageBox( hWnd,"Aucun rptiteur dfini.","Paramtre invalide",MB_ICONWARNING);
					return ;
			}
		if (strlen(viewerport)==0)
			{
					MessageBox( hWnd,"Aucun port serveur dfini.","Paramtre invalide",MB_ICONWARNING);
					return ;
			}
		if (strlen(repID)==0)
			{
					MessageBox( hWnd,"Aucun ID dfini.","Paramtre invalide",MB_ICONWARNING);
					return ;
			}
		int result=MessageBox( hWnd,"Est-ce que l'utilisateur devra entrer l'ID?","ID",MB_YESNO);
		int result2=MessageBox( hWnd,"Est-ce que l'utilisateur devra entrer le mot de passe?","Mot de Passe",MB_YESNO);
		strcpy(connect_line, "-connect ");
		strcat(connect_line,hostname);
		strcat(connect_line,":");
		strcat(connect_line,viewerport);
		strcat(connect_line," -id ");
		if (result==6) strcat(connect_line,"ask");
		else strcat(connect_line,repID);
		if (http) strcat(connect_line," -proxy");
		strcat(connect_line," -passwd ");
		cMD5 myMD5;
		char *test=myMD5.CalcMD5FromString(data10);
		if (result2==6) strcat(connect_line,"ask");
		else strcat(connect_line,test);
	}
	MessageBox( hWnd,connect_line,"Syntaxe de Ligne de commande",MB_ICONEXCLAMATION);
	FILE *fid;
	char menustrings[1024];
	char myline[150];
	int i=0;
	if (GetModuleFileName(NULL, menustrings, 1024))
						{
							char* p = strrchr(menustrings, '\\');
							if (p == NULL) return;
							*p = '\0';
							strcat (menustrings,"\\server_res\\helpdesk.txt");
						}
	if ((fid = fopen(menustrings, "w"))!=NULL)
	{
		fputs(connect_line,fid);
		fputs(eol,fid);
		fclose(fid);
	}
	Copy_to_custom();
	char mypath[1024];
	if (GetModuleFileName(NULL, mypath, 1024))
				{
				char* p = strrchr(mypath, '\\');
				if (p == NULL) return;
				*p = '\0';
				strcat(mypath  ,"\\create_server");
				}
	ShellExecute(hWnd, "open", "create.bat", data1 ,mypath, SW_SHOWNORMAL);
}





void
SaveData(HWND hWnd)
{
	char data1[150];
							strcpy(data1,"");
							char data2[150];
							strcpy(data2,"");
							char data3[150];
							strcpy(data3,"");
							char data4[150];
							strcpy(data4,"");
							char data5[150];
							strcpy(data5,"");
							char data7[150];
							strcpy(data7,"");
							char data8[150];
							strcpy(data8,"");
							char data9[150];
							strcpy(data9,"");
							char data10[150];
							ZeroMemory(data10,150);


							SendDlgItemMessage(hWnd,IDC_EDIT1, WM_GETTEXT, 150, (LONG)data1);
							if (strlen(data1)==0) 
							{
								MessageBox( hWnd,"Aucun alias dfini","Erreur: Paramtre invalide",MB_ICONWARNING);
								return;
							}
							SendDlgItemMessage(hWnd,IDC_EDIT1, WM_GETTEXT, 150, (LONG)data1);
							SendDlgItemMessage(hWnd,IDC_EDIT2, WM_GETTEXT, 150, (LONG)data2);
							SendDlgItemMessage(hWnd,IDC_EDIT3, WM_GETTEXT, 150, (LONG)data3);
							SendDlgItemMessage(hWnd,IDC_EDIT4, WM_GETTEXT, 150, (LONG)data4);
							SendDlgItemMessage(hWnd,IDC_EDIT5, WM_GETTEXT, 150, (LONG)data5);
							SendDlgItemMessage(hWnd,IDC_EDIT7, WM_GETTEXT, 150, (LONG)data7);
							SendDlgItemMessage(hWnd,IDC_EDIT8, WM_GETTEXT, 150, (LONG)data8);
							SendDlgItemMessage(hWnd,IDC_EDIT9, WM_GETTEXT, 150, (LONG)data9);
							SendDlgItemMessage(hWnd,IDC_EDIT10, WM_GETTEXT, 150, (LONG)data10);

							char WORKDIR[MAX_PATH];
							char FULLFILL[MAX_PATH];
							if (GetModuleFileName(NULL, WORKDIR, MAX_PATH))
							{
							char* p = strrchr(WORKDIR, '\\');
								if (p == NULL) return;
								*p = '\0';
							}
							strcpy(FULLFILL,"");
							strcat(FULLFILL,WORKDIR);//set the directory
							strcat(FULLFILL,"\\connections\\");
							strcat(FULLFILL,data1);
							strcat(FULLFILL,".phw");
							WritePrivateProfileString("pchw","data1", (char *)data1,FULLFILL);
							WritePrivateProfileString("pchw","data2", (char *)data2,FULLFILL);
							WritePrivateProfileString("pchw","data3", (char *)data3,FULLFILL);
							WritePrivateProfileString("pchw","data4", (char *)data4,FULLFILL);
							WritePrivateProfileString("pchw","data5", (char *)data5,FULLFILL);
							WritePrivateProfileString("pchw","data7", (char *)data7,FULLFILL);
							WritePrivateProfileString("pchw","data8", (char *)data8,FULLFILL);
							WritePrivateProfileString("pchw","data9", (char *)data9,FULLFILL);

							CryptoService cs;
							if(cs.Encrypt((BYTE*)data10, strlen(data10)))
								{
									char tempchar[10];
									WritePrivateProfileString("pchw","data10", itoa(cs.GetLength(),tempchar,10),FULLFILL);
									WritePrivateProfileStruct("pchw","passwd", (TCHAR *)cs.GetBuffer(),cs.GetLength(),FULLFILL);
								}
							else
								{	
									WritePrivateProfileStruct("pchw","passwd", " ",1,FULLFILL);
								}

							if (SendMessage(GetDlgItem(hWnd, IDC_CHECK1), BM_GETCHECK, 0, 0) == BST_CHECKED)
								{
									WritePrivateProfileString("pchw","check1", (char *)"1",FULLFILL);
								}
							else
								{
								WritePrivateProfileString("pchw","check1", (char *)"",FULLFILL);
								}

							if (SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_GETCHECK, 0, 0) == BST_CHECKED)
								{
									WritePrivateProfileString("pchw","check2", (char *)"1",FULLFILL);
								}
							else
								{
								WritePrivateProfileString("pchw","check2", (char *)"",FULLFILL);
								}

							if (SendMessage(GetDlgItem(hWnd, IDC_RADIO1), BM_GETCHECK, 0, 0) == BST_CHECKED)
								{
									WritePrivateProfileString("pchw","radio1", (char *)"1",FULLFILL);
								}
							else
								{
								WritePrivateProfileString("pchw","radio1", (char *)"",FULLFILL);
								}

							if (SendMessage(GetDlgItem(hWnd, IDC_HIGH), BM_GETCHECK, 0, 0) == BST_CHECKED)
								{
									WritePrivateProfileString("pchw","high", (char *)"1",FULLFILL);
								}
							else
								{
								WritePrivateProfileString("pchw","high", (char *)"",FULLFILL);
								}

							if (SendMessage(GetDlgItem(hWnd, IDC_MID), BM_GETCHECK, 0, 0) == BST_CHECKED)
								{
									WritePrivateProfileString("pchw","mid", (char *)"1",FULLFILL);
								}
							else
								{
								WritePrivateProfileString("pchw","mid", (char *)"",FULLFILL);
								}

							if (SendMessage(GetDlgItem(hWnd, IDC_LOW), BM_GETCHECK, 0, 0) == BST_CHECKED)
								{
									WritePrivateProfileString("pchw","low", (char *)"1",FULLFILL);
								}
							else
								{
								WritePrivateProfileString("pchw","low", (char *)"",FULLFILL);
								}


							if (SendMessage(GetDlgItem(hWnd, IDC_DEBUG), BM_GETCHECK, 0, 0) == BST_CHECKED)
								{
									WritePrivateProfileString("pchw","debug", (char *)"1",FULLFILL);
								}
							else
								{
								WritePrivateProfileString("pchw","debug", (char *)"",FULLFILL);
								}


							if (SendMessage(GetDlgItem(hWnd, IDC_AUTOCON), BM_GETCHECK, 0, 0) == BST_CHECKED)
								{
									WritePrivateProfileString("pchw","autocon", (char *)"1",FULLFILL);
								}
							else
								{
								WritePrivateProfileString("pchw","autocon", (char *)"",FULLFILL);
								}

							if (SendMessage(GetDlgItem(hWnd, IDC_DIRECTX), BM_GETCHECK, 0, 0) == BST_CHECKED)
								{
									WritePrivateProfileString("pchw","directx", (char *)"1",FULLFILL);
								}
							else
								{
								WritePrivateProfileString("pchw","directx", (char *)"",FULLFILL);
								}

							if (SendMessage(GetDlgItem(hWnd, IDC_UPNP), BM_GETCHECK, 0, 0) == BST_CHECKED)
								{
									WritePrivateProfileString("pchw","upn", (char *)"1",FULLFILL);
								}
							else
								{
								WritePrivateProfileString("pchw","upn", (char *)"",FULLFILL);
								}
}


void
ReadData(char *filename,HWND hWnd)
{
	char data1[150];
	strcpy(data1,"");
	char data2[150];
	strcpy(data2,"");
	char data3[150];
	strcpy(data3,"");
	char data4[150];
	strcpy(data4,"");
	char data5[150];
	strcpy(data5,"");
	char data7[150];
	strcpy(data7,"");
	char data8[150];
	strcpy(data8,"");
	char data9[150];
	strcpy(data9,"");
	char data10[250];
	ZeroMemory(data10,250);
	char check1[10];
	strcpy(check1,"");
	char check2[10];
	strcpy(check2,"");
	char radio1[10];
	strcpy(radio1,"");

	char high[10];
	strcpy(high,"");
	char mid[10];
	strcpy(mid,"");
	char low[10];
	strcpy(low,"");

	char debug[10];
	strcpy(debug,"");
	char autocon[10];
	strcpy(autocon,"");
	char upn[10];
	strcpy(upn,"");
	char directx[10];
	strcpy(directx,"");

	SendDlgItemMessage(hWnd,IDC_EDIT1, WM_SETTEXT, 150, (LONG)data1);
	SendDlgItemMessage(hWnd,IDC_EDIT2, WM_SETTEXT, 150, (LONG)data2);
	SendDlgItemMessage(hWnd,IDC_EDIT3, WM_SETTEXT, 150, (LONG)data3);
	SendDlgItemMessage(hWnd,IDC_EDIT4, WM_SETTEXT, 150, (LONG)data4);
	SendDlgItemMessage(hWnd,IDC_EDIT5, WM_SETTEXT, 150, (LONG)data5);
	SendDlgItemMessage(hWnd,IDC_EDIT7, WM_SETTEXT, 150, (LONG)data7);
	SendDlgItemMessage(hWnd,IDC_EDIT8, WM_SETTEXT, 150, (LONG)data8);
	SendDlgItemMessage(hWnd,IDC_EDIT9, WM_SETTEXT, 150, (LONG)data9);
	SendDlgItemMessage(hWnd,IDC_EDIT10, WM_SETTEXT, 150, (LONG)data10);


	char WORKDIR[MAX_PATH];
	char FULLFILL[MAX_PATH];
	if (GetModuleFileName(NULL, WORKDIR, MAX_PATH))
		{
			char* p = strrchr(WORKDIR, '\\');
			if (p == NULL) return;
			*p = '\0';
		}
	strcpy(FULLFILL,"");
	strcat(FULLFILL,WORKDIR);//set the directory
	strcat(FULLFILL,"\\connections\\");
	strcat(FULLFILL,filename);
	GetPrivateProfileString("pchw","data1", "",(char *)data1,150,FULLFILL);
	GetPrivateProfileString("pchw","data2", "",(char *)data2,150,FULLFILL);
	GetPrivateProfileString("pchw","data3", "",(char *)data3,150,FULLFILL);
	GetPrivateProfileString("pchw","data4", "",(char *)data4,150,FULLFILL);
	GetPrivateProfileString("pchw","data5", "",(char *)data5,150,FULLFILL);
	GetPrivateProfileString("pchw","data7", "",(char *)data7,150,FULLFILL);
	GetPrivateProfileString("pchw","data8", "",(char *)data8,150,FULLFILL);
	GetPrivateProfileString("pchw","data9", "",(char *)data9,150,FULLFILL);
	GetPrivateProfileString("pchw","data10", "",(char *)data10,150,FULLFILL);
	int size=atoi(data10);
	GetPrivateProfileStruct("pchw","passwd",(char *)data10,size,FULLFILL);
	GetPrivateProfileString("pchw","check1", "",(char *)check1,10,FULLFILL);
	GetPrivateProfileString("pchw","check2", "",(char *)check2,10,FULLFILL);
	GetPrivateProfileString("pchw","radio1", "",(char *)radio1,10,FULLFILL);

	GetPrivateProfileString("pchw","high", "",(char *)high,10,FULLFILL);
	GetPrivateProfileString("pchw","mid", "",(char *)mid,10,FULLFILL);
	GetPrivateProfileString("pchw","low", "",(char *)low,10,FULLFILL);

	GetPrivateProfileString("pchw","autocon", "",(char *)autocon,10,FULLFILL);
	GetPrivateProfileString("pchw","debug", "",(char *)debug,10,FULLFILL);
	GetPrivateProfileString("pchw","upn", "",(char *)upn,10,FULLFILL);
	GetPrivateProfileString("pchw","directx", "",(char *)directx,10,FULLFILL);

	char passwd[64];
	CryptoService cs;
	//if (strlen(data10)!=0)
	//{
		if(cs.Decrypt((BYTE*)data10, 150))
			{
				memset(passwd,0,64);
				memcpy(passwd,(char *)cs.GetBuffer(),cs.GetLength());
				SetWindowText(GetDlgItem(hWnd,IDC_EDIT10),passwd);
			}
	//}
	//else SetWindowText(GetDlgItem(hWnd,IDC_EDIT10),"");

	SendDlgItemMessage(hWnd,IDC_EDIT1, WM_SETTEXT, 150, (LONG)data1);
	SendDlgItemMessage(hWnd,IDC_EDIT2, WM_SETTEXT, 150, (LONG)data2);
	SendDlgItemMessage(hWnd,IDC_EDIT3, WM_SETTEXT, 150, (LONG)data3);
	SendDlgItemMessage(hWnd,IDC_EDIT4, WM_SETTEXT, 150, (LONG)data4);
	SendDlgItemMessage(hWnd,IDC_EDIT5, WM_SETTEXT, 150, (LONG)data5);
	SendDlgItemMessage(hWnd,IDC_EDIT7, WM_SETTEXT, 150, (LONG)data7);
	SendDlgItemMessage(hWnd,IDC_EDIT8, WM_SETTEXT, 150, (LONG)data8);
	SendDlgItemMessage(hWnd,IDC_EDIT9, WM_SETTEXT, 150, (LONG)data9);

	if (strlen(check1)!=0) G_DYNALIAS=true;
	else G_DYNALIAS=false;
	if (strlen(check2)!=0) G_PROXY=true;
	else G_PROXY=false;
	if (strlen(radio1)!=0) G_RADIO=false;
	else G_RADIO=true;

	if (strlen(high)!=0) G_HIGH=true;
	else G_HIGH=false;
	if (strlen(mid)!=0) G_MID=true;
	else G_MID=false;
	if (strlen(low)!=0) G_LOW=true;
	else G_LOW=false;

	if (strlen(debug)!=0) G_DEBUG=true;
	else G_DEBUG=false;
	if (strlen(autocon)!=0) G_AUTOCON=true;
	else G_AUTOCON=false;
	if (strlen(upn)!=0) G_UPN=true;
	else G_UPN=false;

	if (strlen(directx)!=0) G_DIRECTX=true;
	else G_DIRECTX=false;

	if (G_UPN)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_UPNP);
								SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_UPNP);
								SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

	if (G_AUTOCON)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_AUTOCON);
								SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_AUTOCON);
								SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

	if (G_DEBUG)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_DEBUG);
								SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_DEBUG);
								SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

	if (G_DIRECTX)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_DIRECTX);
								SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_DIRECTX);
								SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

	if (G_HIGH)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_HIGH);
								SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_HIGH);
								SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

	if (G_MID)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_MID);
								SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_MID);
								SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

	if (G_LOW)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_LOW);
								SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_LOW);
								SendMessage(hRadio, BM_SETCHECK, false, 0);
				}


	if (G_PROXY)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_CHECK2);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_CHECK2);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

	if (G_DYNALIAS)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_CHECK1);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_CHECK1);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

	if (!G_RADIO)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_RADIO1);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
					hRadio=GetDlgItem(hWnd,IDC_RADIO2);
					SendMessage(hRadio, BM_SETCHECK, false, 0);

					EnableWindow(GetDlgItem(hWnd, IDC_EDIT2),true);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),false);
						EnableWindow(GetDlgItem(hWnd, IDC_CHECK1),true);

						EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT6),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT3),false);
						EnableWindow(GetDlgItem(hWnd, IDC_CHECK2),false);

						if (SendMessage(GetDlgItem(hWnd, IDC_CHECK1), BM_GETCHECK, 0, 0) == BST_CHECKED)
						{
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),true);
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),true);
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),true);
						}
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_RADIO1);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
					hRadio=GetDlgItem(hWnd,IDC_RADIO2);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT2),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),false);
						EnableWindow(GetDlgItem(hWnd, IDC_CHECK1),false);
						EnableWindow(GetDlgItem(hWnd, IDC_CHECK2),true);

						EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),true);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),true);
//						EnableWindow(GetDlgItem(hWnd, IDC_EDIT6),true);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),true);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT3),true);
				}

}

void
FillListbox(HWND m_hcombo)
{
	HANDLE fileh;
	WIN32_FIND_DATA finddata;
	char WORKDIR[MAX_PATH];
	char FULLFILL[MAX_PATH];
	char FILENAME[MAX_PATH];
	TCHAR szString[MAX_PATH];
	bool is;
	if (GetModuleFileName(NULL, WORKDIR, MAX_PATH))
				{
				char* p = strrchr(WORKDIR, '\\');
					if (p == NULL) return;
					*p = '\0';
				}
	strcpy(FULLFILL,"");
	strcat(FULLFILL,WORKDIR);//set the directory
	strcat(FULLFILL,"\\connections\\*.phw");//set the filter
	fileh=FindFirstFile(FULLFILL,&finddata);
    SendMessage (m_hcombo, LB_RESETCONTENT, 0, (LPARAM)finddata.cFileName);
	if (fileh == INVALID_HANDLE_VALUE) 
	{
	}
	else
	{
	SendMessage (m_hcombo, LB_ADDSTRING, 0, (LPARAM)finddata.cFileName);
	is=FindNextFile(fileh,&finddata);
	while(is)
		{
		if(finddata.dwFileAttributes!=FILE_ATTRIBUTE_DIRECTORY )//we dont want any directory listings do we? 
	        {
				if(is)
					SendMessage (m_hcombo, LB_ADDSTRING, 0, (LPARAM)finddata.cFileName);
			}
		is=FindNextFile(fileh,&finddata);
		}
    SendMessage (m_hcombo, LB_SETCURSEL, (WPARAM)0, 0);
	FindClose(fileh);
	}
}


extern const UINT UWM_PORT_FORWARD_ENGINE_THREAD_NOTIFICATION;







LRESULT CALLBACK
DialogProcStatic(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	  if (Message==UWM_PORT_FORWARD_ENGINE_THREAD_NOTIFICATION)
	  {
		  if ( wParam == 0x0012 )
			{
				char model[150];
				if ( SUCCEEDED(lParam) )
					{				
						Getinfo(model);
						SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)model);
						if (upnp_map==true)
						{
							upnp_map=false;
							SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);
							char port[10];
							SendDlgItemMessage(hWnd,IDC_EDIT2, WM_GETTEXT, 10, (LONG)port);
							if (strlen(port)!=0)
							{
								add_mapping( atoi(port));
							}
							else SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Port d'coute non dfini");
						}
						if (upnp_unmap==true)
						{
							upnp_unmap=false;
							SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);				
							remove_mapping();
						}
					}
				else
					{
					    SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);
						SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Upnp Indisponible");
						HWND hRadio=GetDlgItem(hWnd,IDC_UPNP);
						SendMessage(hRadio, BM_SETCHECK, false, 0);
						G_UPN=false;
						upnp_map=false;
						upnp_unmap=false;
					}
			}
		  if ( wParam == 0x0022 )
			{
		  		if ( !SUCCEEDED(lParam) )
				{
					// error: display message only
					SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);
					SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Impossible d'ajouter le mappage");
				}
				else
				{
					SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);
					SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Mappage Effectu");
				}
		  }

		  if ( wParam == 0x0082 )
			{
				// the thread is finished
				
				if ( !SUCCEEDED(lParam) )
				{
					// error: display message only
					SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);
					SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Impossible de suppr le mappage");
				}
				else
				{
					SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);
					SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Mappage Supprim");
				}			
			}
		  if ( wParam == 0x0011 ||  wParam == 0x0021  || wParam == 0x0081)
			{
				SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) lParam, 0);
			}

	  }

  switch(Message)
  {
		case WM_CLOSE:
			{
			     EndDialog(hWnd,0); // kill dialog
			}
			break;
		case WM_INITDIALOG:
			{
				main_window=hWnd;
				FillListbox(GetDlgItem(hWnd,IDC_LIST1));

				EnableWindow(GetDlgItem(hWnd, ID_STOP),false);

				if (G_HIGH)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_HIGH);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_HIGH);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
				}
				if (G_MID)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_MID);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_MID);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
				}
				if (G_LOW)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_LOW);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_LOW);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

				if (G_DEBUG)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_DEBUG);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_DEBUG);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

				if (G_AUTOCON)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_AUTOCON);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_AUTOCON);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

				if (G_UPN)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_UPNP);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_UPNP);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
				}


				if (G_PROXY)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_CHECK2);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_CHECK2);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

				if (G_DYNALIAS)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_CHECK1);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_CHECK1);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
				}

				if (!G_RADIO)
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_RADIO1);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
					hRadio=GetDlgItem(hWnd,IDC_RADIO2);
					SendMessage(hRadio, BM_SETCHECK, false, 0);

					EnableWindow(GetDlgItem(hWnd, IDC_EDIT2),true);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),false);
						EnableWindow(GetDlgItem(hWnd, IDC_CHECK1),true);

						EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),false);
//						EnableWindow(GetDlgItem(hWnd, IDC_EDIT6),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),false);
						EnableWindow(GetDlgItem(hWnd, IDC_TEST),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT3),false);
						EnableWindow(GetDlgItem(hWnd, IDC_CHECK2),false);

						if (SendMessage(GetDlgItem(hWnd, IDC_CHECK1), BM_GETCHECK, 0, 0) == BST_CHECKED)
						{
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),true);
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),true);
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),true);
							EnableWindow(GetDlgItem(hWnd, IDC_TEST),true);
						}
						if (SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_GETCHECK, 0, 0) == BST_CHECKED)
						{
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),false);
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),false);
						}
				}
				else
				{
					HWND hRadio=GetDlgItem(hWnd,IDC_RADIO1);
					SendMessage(hRadio, BM_SETCHECK, false, 0);
					hRadio=GetDlgItem(hWnd,IDC_RADIO2);
					SendMessage(hRadio, BM_SETCHECK, true, 0);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT2),false);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),false);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECK1),false);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECK2),true);

					EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),true);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),true);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT6),true);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),false);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),true);
					EnableWindow(GetDlgItem(hWnd, IDC_TEST),true);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT3),true);
					if (SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_GETCHECK, 0, 0) == BST_CHECKED)
						{
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),false);
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),false);
						}
						break;
				}
				return false;
			}
								
     // This Window Message will control the dialog  //
	//==============================================//
        case WM_COMMAND:
			switch (LOWORD(wParam))
				{
					case IDC_HIGH:
					case IDC_MID:
					case IDC_LOW:
						{
							COPYDATASTRUCT MyCDS;
							if (SendMessage(GetDlgItem(hWnd, IDC_HIGH), BM_GETCHECK, 0, 0)== BST_CHECKED)
								{
									MyCDS.dwData=70;
								}
							if (SendMessage(GetDlgItem(hWnd, IDC_MID), BM_GETCHECK, 0, 0)== BST_CHECKED)
								{
									MyCDS.dwData=71;
								}
							if (SendMessage(GetDlgItem(hWnd, IDC_LOW), BM_GETCHECK, 0, 0)== BST_CHECKED)
								{
									MyCDS.dwData=72;
								}
							MyCDS.cbData=1;
							MyCDS.lpData="1";
							HWND hh=FindWindow("SCVIEWER_M",NULL);
							if (hh!=NULL) SendMessage(hh,WM_COPYDATA,(WPARAM)hWnd,(LPARAM)&MyCDS);
						}
						break;

					case IDC_BUTTON5:
					case ID_WIZARD:
						create_server(hWnd);
						break;
						case IDC_LIST1:
							// It's our listbox, check the notification code
							switch(HIWORD(wParam))
							{
								case LBN_SELCHANGE:
									char temp[100];
									HWND hList = GetDlgItem(hWnd, IDC_LIST1);
									 int count = SendMessage(hList, LB_GETCURSEL, 0, 0);
									 SendMessage(hList,  LB_GETTEXT, count, (LPARAM)temp);
									 ReadData(temp,hWnd);
								break;
							}
						break;


					case IDC_RADIO1: //listen
						G_RADIO=false;
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT2),true);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),false);
						EnableWindow(GetDlgItem(hWnd, IDC_CHECK1),true);

						EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),false);
						EnableWindow(GetDlgItem(hWnd, IDC_TEST),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT3),false);
						EnableWindow(GetDlgItem(hWnd, IDC_CHECK2),false);

						if (SendMessage(GetDlgItem(hWnd, IDC_CHECK1), BM_GETCHECK, 0, 0) == BST_CHECKED)
						{
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),true);
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),true);
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),true);
							EnableWindow(GetDlgItem(hWnd, IDC_TEST),true);
						}
						if (SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_GETCHECK, 0, 0) == BST_CHECKED)
						{
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),false);
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),false);
						}

						break;
					case IDC_RADIO2:  //repeater
						G_RADIO=true;
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT2),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),false);
						EnableWindow(GetDlgItem(hWnd, IDC_CHECK1),false);
						EnableWindow(GetDlgItem(hWnd, IDC_CHECK2),true);

						EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),true);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),true);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),false);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),true);
						EnableWindow(GetDlgItem(hWnd, IDC_TEST),true);
						EnableWindow(GetDlgItem(hWnd, IDC_EDIT3),true);
						if (SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_GETCHECK, 0, 0) == BST_CHECKED)
						{
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),false);
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),false);
						}
						break;
					case IDC_CHECK1:
						if (SendMessage(GetDlgItem(hWnd, IDC_CHECK1), BM_GETCHECK, 0, 0) == BST_CHECKED)
						{
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),true);
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),true);
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),true);
							EnableWindow(GetDlgItem(hWnd, IDC_TEST),true);
						}
						else
						{
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT8),false);
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT7),false);
							EnableWindow(GetDlgItem(hWnd, IDC_EDIT9),false);
							EnableWindow(GetDlgItem(hWnd, IDC_TEST),false);
						}
						break;
					case IDC_CHECK2:
						if (SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_GETCHECK, 0, 0) == BST_CHECKED)
						{
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),false);
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),false);
						}
						else 
						{
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT4),true);
								EnableWindow(GetDlgItem(hWnd, IDC_EDIT5),true);
						}
						break;
					case ID_START:
						{
							//listen or repeater
							bool listen=false;
							bool repeater=false;
							bool upnp=false;
							bool dynalias=false;
							bool debug=false;
							bool http=false;
							int bandwidth=1;

							char hostname[100];
							char password[100];
							char portdynalias[10];
							char alias[100];
							char listenport[10];
							char viewerport[10];
							char repID[10];

							ZeroMemory(hostname,100);
							ZeroMemory(password,100);
							ZeroMemory(alias,100);
							ZeroMemory(portdynalias,10);
							ZeroMemory(listenport,10);
							ZeroMemory(viewerport,10);
							ZeroMemory(repID,10);

							
						

							SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_RESETCONTENT, 0, (LPARAM)"");
							if (SendMessage(GetDlgItem(hWnd, IDC_RADIO1), BM_GETCHECK, 0, 0) == BST_CHECKED)
							{
								listen=true;
								repeater=false;
							}
							else
							{
								listen=false;
								repeater=true;
							}
							if (SendMessage(GetDlgItem(hWnd, IDC_DEBUG), BM_GETCHECK, 0, 0) == BST_CHECKED) debug=true;
								else debug=false;

							ZeroMemory(password,100);
							SendDlgItemMessage(hWnd,IDC_EDIT10, WM_GETTEXT, 150, (LONG)password);

							if (SendMessage(GetDlgItem(hWnd, IDC_HIGH), BM_GETCHECK, 0, 0)== BST_CHECKED)
									{
										bandwidth=1;
									}
							if (SendMessage(GetDlgItem(hWnd, IDC_MID), BM_GETCHECK, 0, 0)== BST_CHECKED)
									{
										bandwidth=2;
									}
							if (SendMessage(GetDlgItem(hWnd, IDC_LOW), BM_GETCHECK, 0, 0)== BST_CHECKED)
									{
										bandwidth=4;
									}

							if (SendMessage(GetDlgItem(hWnd, IDC_DIRECTX), BM_GETCHECK, 0, 0)== BST_CHECKED)
									{
										G_use_directx=false;
									}
							else
									{
										G_use_directx=true;
									}

							


							if (listen)
							{
								if (SendMessage(GetDlgItem(hWnd, IDC_UPNP), BM_GETCHECK, 0, 0) == BST_CHECKED) upnp=true;
								else upnp=false;
								SendDlgItemMessage(hWnd,IDC_EDIT2, WM_GETTEXT, 10, (LONG)listenport);
								if (strlen(listenport)==0) 
								{
									SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Port d'coute non dfini.");
									return 0;
								}
								if (SendMessage(GetDlgItem(hWnd, IDC_CHECK1), BM_GETCHECK, 0, 0) == BST_CHECKED) dynalias=true;
								else dynalias=false;
								if (dynalias)
								{
									SendDlgItemMessage(hWnd,IDC_EDIT9, WM_GETTEXT, 150, (LONG)hostname);
									SendDlgItemMessage(hWnd,IDC_EDIT7, WM_GETTEXT, 10, (LONG)portdynalias);
									SendDlgItemMessage(hWnd,IDC_EDIT8, WM_GETTEXT, 150, (LONG)alias);
										if (strlen(hostname)!=0)
										{
											if (strlen(portdynalias)!=0)
											{
												if (strlen(alias)!=0)
												{
													if (!Set_dynamic_host(alias, hostname, atoi(portdynalias)))
														{
															SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Echec de la mise en place de l'alias.");
															return 0;
														}
													else SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Alias dyn mis en place sur le serveur.");
												}
												else
												{
													SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Aucun alias dyn dfini.");
													return 0;
												}
											}
											else
											{
												SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Aucun port dyn dfini.");
												return 0;
											}
										}
										else
										{
											SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Aucun rptiteur dfini.");
											return 0;
										}

								}//dynalias
								if (upnp)
								{
								upnp_map=true;
								SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_RESETCONTENT, 0, (LPARAM)"");
								SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Test: Upnp");
								SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETRANGE, 0, MAKELPARAM(0,10));
								GetDeviceInformation();
								SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);
								}

								Start_viewer("", "",atoi(listenport),0,password,debug,0,bandwidth,G_use_directx);
								EnableWindow(GetDlgItem(hWnd, ID_START),false);
								EnableWindow(GetDlgItem(hWnd, ID_STOP),true);

							}//listen
							else
							{
								SendDlgItemMessage(hWnd,IDC_EDIT9, WM_GETTEXT, 150, (LONG)hostname);
								SendDlgItemMessage(hWnd,IDC_EDIT4, WM_GETTEXT, 10, (LONG)viewerport);
								SendDlgItemMessage(hWnd,IDC_EDIT3, WM_GETTEXT, 10, (LONG)repID);
								if (SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_GETCHECK, 0, 0) == BST_CHECKED) http=true;
								else http=false;
								if (strlen(hostname)!=0)
									{
										if (strlen(viewerport)!=0)
											{
												if (strlen(repID)!=0)
													{
														Start_viewer(repID, hostname,0,atoi(viewerport),password,debug,http,bandwidth,G_use_directx);	
														EnableWindow(GetDlgItem(hWnd, ID_START),false);
														EnableWindow(GetDlgItem(hWnd, ID_STOP),true);
													}
												else
													{
														SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Aucun ID dfini.");
														return 0;
													}
											}
										else
											{
												SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Aucun port client dfini.");
												return 0;
											}
									}
								else
									{
										SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Aucun rptiteur dfini.");
											return 0;
									}

							}// else repeater
							strcpy(G_hostname,hostname);
							strcpy(G_repID,repID);
							strcpy(G_listenport,listenport);
							strcpy(G_viewerport,viewerport);
							strcpy(G_password,password);
							G_debug=debug;
							G_http=http;
							G_bandwidth=bandwidth;
							G_upnp=upnp;
							

						}
						break;
					case ID_STOP:
						Start_viewer("", "",0,0,"",0,0,99,0);
						break;
					case ID_QUIT:
						Start_viewer("", "",0,0,"",0,0,99,0);
						EndDialog(hWnd,0);
						break;
					case IDC_SAVE:
						{
							SaveData(hWnd);
							FillListbox(GetDlgItem(hWnd,IDC_LIST1));
						}
						break;
					case ID_DELETE:
						{
							char temp[100];
							HWND hList = GetDlgItem(hWnd, IDC_LIST1);
							int count = SendMessage(hList, LB_GETCURSEL, 0, 0);
							if (count!=-1)
							{
								SendMessage(hList,  LB_GETTEXT, count, (LPARAM)temp);
								char WORKDIR[MAX_PATH];
								char FULLFILL[MAX_PATH];
								if (GetModuleFileName(NULL, WORKDIR, MAX_PATH))
									{
										char* p = strrchr(WORKDIR, '\\');
										if (p == NULL) return 0;
										*p = '\0';
									}
								strcpy(FULLFILL,"");
								strcat(FULLFILL,WORKDIR);//set the directory
								strcat(FULLFILL,"\\connections\\");
								strcat(FULLFILL,temp);
								DeleteFile(FULLFILL);
								Sleep(250);
								FillListbox(GetDlgItem(hWnd,IDC_LIST1));
							}
						}
						break;

					case IDC_TEST_UPNP:
						upnp_map=true;
						SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_RESETCONTENT, 0, (LPARAM)"");
						SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Test: Upnp");
						SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETRANGE, 0, MAKELPARAM(0,10));
						GetDeviceInformation();
						SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);
						break;
					case IDC_UMAP_UPNP:
						upnp_unmap=true;
						SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_RESETCONTENT, 0, (LPARAM)"");
						SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Test: Upnp");
						SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETRANGE, 0, MAKELPARAM(0,10));
						GetDeviceInformation();
						SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);
						break;
					case IDC_TEST:
						{
							char hostname[100];
							char alias[100];
							char portviewer[10];
							char portserver[10];
							char porthttp[10];
							char portdynalias[10];
							SendDlgItemMessage(hWnd,IDC_EDIT8, WM_GETTEXT, 150, (LONG)alias);
							SendDlgItemMessage(hWnd,IDC_EDIT9, WM_GETTEXT, 150, (LONG)hostname);
							SendDlgItemMessage(hWnd,IDC_EDIT4, WM_GETTEXT, 10, (LONG)portviewer);
							SendDlgItemMessage(hWnd,IDC_EDIT5, WM_GETTEXT, 10, (LONG)portserver);
							SendDlgItemMessage(hWnd,IDC_EDIT7, WM_GETTEXT, 10, (LONG)portdynalias);
							SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_RESETCONTENT, 0, (LPARAM)"");
							SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Test Rptiteur");
							if (strlen(hostname)!=0)
							{
								if (strlen(portdynalias)!=0)
								{
									if (strlen(alias)!=0)
									{
										char viewer_ip[100];
										char myhost[100];
										char text[150];
										if (!Set_dynamic_host(alias, hostname, atoi(portdynalias)))
										{
											SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Echec de la mise en place de l'alias.");
											return true;
										}
										if (!Get_dynamic_host(alias, hostname, atoi(portdynalias),viewer_ip))
										{
											SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Echec de l'acquisition de l'alias.");
											return true;
										}
										strcpy(text,"IP externe: ");
										strcat(text,viewer_ip);
										SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)text);
										if (gethostname(myhost, sizeof(myhost))!= SOCKET_ERROR)
											{
												struct hostent *phe = gethostbyname(myhost);
												struct in_addr addr;
												if (phe) 
												{
													sprintf(viewer_ip,"%d.%d.%d.%d",
													(unsigned char) phe->h_addr_list[0][0],
													(unsigned char) phe->h_addr_list[0][1], 
													(unsigned char) phe->h_addr_list[0][2],
													(unsigned char) phe->h_addr_list[0][3]);

													strcpy(text,"IP locale: ");
													strcat(text,viewer_ip);
													SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)text);
												}
											}


									}
									else SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Vous n'avez pas indiqu d'aliasdyn pour tester le port dyn.");
								}

								if (strlen(portviewer)!=0)
								{
									if (Test_remote_port(hostname, atoi(portviewer)))
									{
										SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Port client OK.");
									}
									else SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Echec de la connexion au port client.");
								}
								if (strlen(portserver)!=0)
								{
									if (Test_remote_port(hostname, atoi(portserver)))
									{
										SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Port serveur OK.");
									}
									else SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Echec de la connexion au port serveur.");
								}

								if (SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_GETCHECK, 0, 0) == BST_CHECKED)
									{
										int mysock=Get_https_socket("443", hostname);
										if (mysock) 
										{
											shutdown(mysock, SD_BOTH);
											closesocket(mysock);
										}
									}
							}
							else
							{
									SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Aucun rptiteur dfini.");
							}
						}

				}
			case WM_SYSCOMMAND:
				switch (LOWORD(wParam))
				{
				case WM_USER+13:
					EnableWindow(GetDlgItem(hWnd, ID_START),true);
					EnableWindow(GetDlgItem(hWnd, ID_STOP),false);
					if (SendMessage(GetDlgItem(hWnd, IDC_AUTOCON), BM_GETCHECK, 0, 0) == BST_CHECKED)
						{
							Start_viewer(G_repID, G_hostname,atoi(G_listenport),atoi(G_viewerport),G_password,G_debug,G_http,G_bandwidth,G_use_directx);
							EnableWindow(GetDlgItem(hWnd, ID_START),false);
							EnableWindow(GetDlgItem(hWnd, ID_STOP),true);
						}
					else
						{	
							if (G_upnp)
							{
							upnp_unmap=true;
							SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_RESETCONTENT, 0, (LPARAM)"");
							SendMessage (GetDlgItem(hWnd, IDC_LIST2), LB_ADDSTRING, 0, (LPARAM)"Test: Upnp");
							SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETRANGE, 0, MAKELPARAM(0,10));
							GetDeviceInformation();
							SendDlgItemMessage(hWnd, IDC_PROGRESS1, PBM_SETPOS, (WPARAM) 0, 0);
							}							
						}
					break;
				case WM_USER+14:
					break;
				}
		default:return FALSE;
   }
	return TRUE;
}



void EmtyDir()
{
     SHFILEOPSTRUCT sfo;
     ZeroMemory(&sfo, sizeof(SHFILEOPSTRUCT));
     sfo.wFunc = FO_DELETE;
     sfo.pFrom = "c:\\temp_phw\\*.*\0";
     sfo.fFlags = FOF_SILENT | FOF_NOCONFIRMATION | FOF_NOERRORUI ;
     SHFileOperation(&sfo);
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwICC = ICC_LISTVIEW_CLASSES|ICC_INTERNET_CLASSES;
	InitCtrls.dwSize = sizeof(INITCOMMONCONTROLSEX);
	BOOL bRet = InitCommonControlsEx(&InitCtrls);
	if (!ImportDLL_functions())
	{
		MessageBox(NULL, "Echec du chargement de 1SCVDLL.dll", NULL, MB_OK);
		return 0;
	}

	g_hinst=hInstance;
	WSADATA wsaData;
	int result = WSAStartup(MAKEWORD(2, 0), &wsaData);	
	CreateDirectory("c:\\temp_phw", NULL);
	char WORKDIR[MAX_PATH];
	char FULLFILL[MAX_PATH];
	if (GetModuleFileName(NULL, WORKDIR, MAX_PATH))
			{
				char* p = strrchr(WORKDIR, '\\');
				if (p == NULL) return 0;
					*p = '\0';
			}
	strcpy(FULLFILL,"");
	strcat(FULLFILL,WORKDIR);//set the directory
	strcat(FULLFILL,"\\connections");
	CreateDirectory(FULLFILL, NULL);
	strcpy(FULLFILL,"");
	strcat(FULLFILL,WORKDIR);//set the directory
	strcat(FULLFILL,"\\cache");
	CreateDirectory(FULLFILL, NULL);
	strcpy(FULLFILL,"");
	strcat(FULLFILL,WORKDIR);//set the directory
	strcat(FULLFILL,"\\server_res");
	CreateDirectory(FULLFILL, NULL);
	strcpy(FULLFILL,"");
	strcat(FULLFILL,WORKDIR);//set the directory
	strcat(FULLFILL,"\\myservers");
	CreateDirectory(FULLFILL, NULL);
	
	WNDCLASS wc = {0}; 
	wc.style = CS_BYTEALIGNWINDOW|CS_SAVEBITS|CS_DBLCLKS; 
	wc.lpfnWndProc = DefDlgProc; 
	wc.cbWndExtra = DLGWINDOWEXTRA; 
	wc.hInstance = hInstance; 
//	wc.hIcon = LoadIcon(IDI_ICON1); 
	wc.hCursor = ::LoadCursor(NULL, IDC_ARROW); 
	wc.hbrBackground = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)); 
	wc.lpszClassName = "PcHelpWare Control Viewer"; 
	ATOM cls = RegisterClass(&wc); 
	DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC)DialogProcStatic,(LPARAM)NULL);


	EmtyDir();
	WSACleanup();
	while (AnyThread()) Sleep(50);
	Sleep(2500); //we need to give some otehr threads time to shutdown.
	Free_DLL_functions();
	return 0;
}
