// 1SC.cpp : Defines the entry point for the application.
//
//
// WM_APP+1 disconnect
// WM_APP+2 waiting viewer
// WM_APP+3 connected
// WM_APP+4 disconnecting
// WM_APP+5 user press exit in tray
//
//
//
// void Start_server(char *ID, char *repeater,char *direct,int port,char *passwd,bool proxy,char *classname,bool have_to_wait);
// void Stop_server(void);


#include <winsock2.h>
#include <windows.h>
#include <shellapi.h>
#include <commctrl.h>
#include <stdio.h>
#include <process.h>
#include "resource.h"

#ifndef LWA_COLORKEY
# define LWA_COLORKEY 1
#endif
#ifndef LWA_ALPHA
# define LWA_ALPHA 2
#endif
#ifndef WS_EX_LAYERED
# define WS_EX_LAYERED 0x80000
#endif

//#define CRASH_ENABLED
#ifdef CRASH_ENABLED
#ifndef _CRASH_RPT_
#include "../crashrpt.h"
#pragma comment(lib, "../crashrpt.lib")
#endif
#endif

typedef void (/*__declspec(dllimport)*/ *Start_server_fn)(char *,char *,char *,int,char *,bool,char *,bool);
typedef void (/*__declspec(dllimport)*/ *Stop_server_fn)(void);
Start_server_fn Start_server=NULL;
Stop_server_fn Stop_server=NULL;
HMODULE hDLL=NULL;


//dialog entercode
BOOL CALLBACK DialogProc2(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam);
BOOL DoSDKEraseBkGnd3(IN CONST HDC hDC,IN CONST COLORREF crBkGndFill);
HBITMAP DoGetBkGndBitmap3(IN CONST UINT uBmpResId );


//main dialog
HBITMAP DoGetBkGndBitmap(IN CONST UINT uBmpResId );
BOOL DoSDKEraseBkGnd(IN CONST HDC hDC,IN CONST COLORREF crBkGndFill);
BOOL CALLBACK DialogProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam);



HINSTANCE g_hinst;
HWND master_hwnd; //hwnd_dialog
static HWND hList=NULL;  // List View identifier
LVCOLUMN LvCol; // Make Coluom struct for ListView
LVITEM LvItem;  // ListView Item struct
int g_position=0; //remeber selected item

int wdd=0;// used to stretch background image
int htd=0;//
bool backgr_trans=0;


char		g_var[25][150];
char		g_var_20[25][50];

char		Passwd[150]="";
char		TextTop[150]="";
char		TextError[150]="";
char		TextMiddle[150]="";
char		TextBottom[150]="";
char		TextRTop[150]="";
char		TextRBottom[150]="";
char		TextButton[150]="";
char		TextCButton[150]="";
char		TextRMiddle[150]="";
char		TextTitle[150]="";
char		Webpage[150]="";
bool		bWebpage;
char		Balloon1Title[150]="";
char		Balloon2Title[150]="";
char		Balloon1A[150]="";
char		Balloon1B[150]="";
char		Balloon1C[150]="";
char		Balloon2A[150]="";
char		Balloon2B[150]="";
char		Balloon2C[150]="";
char		TextENTERCODE[150]="";
int			m_mytimerid;
bool		entercode=false;
char		defaultCommandLine[150]="";





bool autoreconnect=false;
bool proxy=false;
bool direct_bool=false; // [DIRECT]
bool waiting_for_quit=false; //Stop_server need to wait until thread end (WM_APP+1)

//Set once and reused on autoconnect
char		G_IDCODE[150]="";
char		G_CHARADRESS[150]="";
int			G_PORT=0;

char		G_DYN_CHARADRESS[150]="";
int			G_DYN_PORT=0;
char		G_DYN_IDCODE[150]="";





/////////////////////////////////////////////////////////////////////////////
// Use repeater as alias server
// myhost==IN alias
// address == IN repeater
// port=IN 5912
// viewer_ip= OUT ip adress of viewer with alias myhost
/////////////////////////////////////////////////////////////////////////////

int
Get_dynamic_host(char *myhost, char *address, int port,char *viewer_ip)
{
	SOCKET sock;
	struct sockaddr_in addr;

	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    {
      return false;
    }
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = inet_addr(address);
	if (addr.sin_addr.s_addr == INADDR_NONE)
	    {
		struct hostent *pHost;
		pHost = gethostbyname(address);
		if (pHost != NULL)
		{
			if (pHost->h_addr == NULL)
				return false;
			addr.sin_addr.s_addr = ((struct in_addr *)pHost->h_addr)->s_addr;
		}
		else
		    return false;
	    }
	addr.sin_port = htons(port);
	if (!connect(sock, (struct sockaddr *)&addr, sizeof(addr)) == 0)
	{
	    return false;
	}

	int timeout=5000;
	if (setsockopt(sock, SOL_SOCKET, SO_RCVTIMEO, (char*)&timeout, sizeof(timeout)) == SOCKET_ERROR)
	{
		return false;
	}
	if (setsockopt(sock, SOL_SOCKET, SO_SNDTIMEO, (char*)&timeout, sizeof(timeout)) == SOCKET_ERROR)
	{
		return false;
	}
	char temp [300];
	strcpy(temp,"IPG:");
	strcat(temp,myhost);
	send(sock, temp, 250, 0);
	recv(sock, viewer_ip, 32, 0);


	shutdown(sock, SD_BOTH);
	closesocket(sock);
	return true;
}


/////////////////////////////////////////////////////////////////////////////
// read the command line 
// sample : -connect dyn:5500 -dynhost uvnc.com:5912 -dynname mytest
// and start the server:  Start_server()
/////////////////////////////////////////////////////////////////////////////

bool Start_my_server()
{
	//We need to convert the string to something usefull for PcHelpWare
	int i;
	for (i = 0; i < strlen(defaultCommandLine); i++)
	{
		defaultCommandLine[i] = tolower(defaultCommandLine[i]);
	}
	BOOL argfound = FALSE;
	for (i = 0; i < strlen(defaultCommandLine); i++)
	{
		if (defaultCommandLine[i] <= ' ')
			continue;
		argfound = TRUE;


		if (strncmp(&defaultCommandLine[i], "-connect", strlen("-connect")) == 0)
		{
			// Add a new client to an existing copy of winvnc
			i+=strlen("-connect");

			// First, we have to parse the command line to get the filename to use
			int start, end;
			start=i;
			while (defaultCommandLine[start] <= ' ' && defaultCommandLine[start] != 0) start++;
			end = start;
			while (defaultCommandLine[end] > ' ') end++;

			// Was there a hostname (and optionally a port number) given?
			if (end-start > 0)
			{
				char *name = new char[end-start+1];
				if (name != 0) {
					strncpy(name, &(defaultCommandLine[start]), end-start);
					name[end-start] = 0;
					int port = 5500;
					char *portp = strchr(name, ':');
					if (portp) {
						*portp++ = '\0';
						if (*portp == ':') {
							port = atoi(++portp);	// Port number after "::"
						} else {
							port = atoi(portp);	// Display number after ":"
						}
					}
					strcpy(G_CHARADRESS,name);
					delete [] name;
					
					G_PORT=port;
				}
				i=end;
				continue;
			}
			continue;
		}

		if (strncmp(&defaultCommandLine[i], "-dynhost", strlen("-dynhost")) == 0)
		{
			// Add a new client to an existing copy of winvnc
			i+=strlen("-dynhost");

			// First, we have to parse the command line to get the filename to use
			int start, end;
			start=i;
			while (defaultCommandLine[start] <= ' ' && defaultCommandLine[start] != 0) start++;
			end = start;
			while (defaultCommandLine[end] > ' ') end++;

			// Was there a hostname (and optionally a port number) given?
			if (end-start > 0)
			{
				char *name = new char[end-start+1];
				if (name != 0) {
					strncpy(name, &(defaultCommandLine[start]), end-start);
					name[end-start] = 0;
					int port = 5500;
					char *portp = strchr(name, ':');
					if (portp) {
						*portp++ = '\0';
						if (*portp == ':') {
							port = atoi(++portp);	// Port number after "::"
						} else {
							port = atoi(portp);	// Display number after ":"
						}
					}
					strcpy(G_DYN_CHARADRESS,name);
					delete [] name;
					
					G_DYN_PORT=port;
				}
				i=end;
				continue;
			}
			continue;
		}

		if (strncmp(&defaultCommandLine[i], "-dynname", strlen("-dynname")) == 0) {
			// Add a new client to an existing copy of winvnc
			i+=strlen("-dynname");

			// First, we have to parse the command line to get the filename to use
			int start, end;
			start = i;
			while (defaultCommandLine[start] <= ' ' && defaultCommandLine[start] != 0) start++;
			end = start;
			while (defaultCommandLine[end] > ' ') end++;
			strcpy(G_DYN_IDCODE,"");
			strncpy(G_DYN_IDCODE,&defaultCommandLine[start],end-start);
			G_IDCODE[end-start]='\0';
			i+=(end-start);
			continue;
		}

		if (strncmp(&defaultCommandLine[i], "-passwd", strlen("-passwd")) == 0) {
			// Add a new client to an existing copy of winvnc
			i+=strlen("-passwd");

			// First, we have to parse the command line to get the filename to use
			int start, end;
			start = i;
			while (defaultCommandLine[start] <= ' ' && defaultCommandLine[start] != 0) start++;
			end = start;
			while (defaultCommandLine[end] > ' ') end++;
			strcpy(Passwd,"");
			strncpy(Passwd,&defaultCommandLine[start],end-start);
			Passwd[end-start]='\0';
			i+=(end-start);
			continue;
		}

		if (strncmp(&defaultCommandLine[i], "-noregistry", strlen("-noregistry")) == 0) {
			// Add a new client to an existing copy of winvnc
			i+=strlen("-noregistry");
		}
		if (strncmp(&defaultCommandLine[i], "-autoreconnect", strlen("-autoreconnect")) == 0) {
			// Add a new client to an existing copy of winvnc
			i+=strlen("-autoreconnect");
			autoreconnect=true;
		}
		if (strncmp(&defaultCommandLine[i], "-proxy", strlen("-proxy")) == 0) {
			// Add a new client to an existing copy of winvnc
			i+=strlen("-proxy");
			proxy=true;
		}
		if (strncmp(&defaultCommandLine[i], "-plugin", strlen("-plugin")) == 0) {
			// Add a new client to an existing copy of winvnc
			i+=strlen("-plugin");
		}

		if (strncmp(&defaultCommandLine[i], "-id", strlen("-id")) == 0) {
			// Add a new client to an existing copy of winvnc
			i+=strlen("-id");

			// First, we have to parse the command line to get the filename to use
			int start, end;
			start = i;
			while (defaultCommandLine[start] <= ' ' && defaultCommandLine[start] != 0) start++;
			end = start;
			while (defaultCommandLine[end] > ' ') end++;
			strcpy(G_IDCODE,"");
			strncpy(G_IDCODE,&defaultCommandLine[start],end-start);
			G_IDCODE[end-start]='\0';
			i+=(end-start);
			continue;
		}


	}
	//

	if (strcmp(G_CHARADRESS,"dyn")==NULL)
	{
		Get_dynamic_host(G_DYN_IDCODE, G_DYN_CHARADRESS, G_DYN_PORT,G_CHARADRESS);
	}

	if (strcmp(G_CHARADRESS,"offline")==NULL)
	{
		MessageBox(NULL, "Viewer is offline, try again later", NULL, MB_OK);
		return false;
	}

	if (entercode)
			{
				ShowWindow(master_hwnd, SW_HIDE ); 
				DialogBoxParam(g_hinst, MAKEINTRESOURCE(IDD_ENTERID), NULL, (DLGPROC)DialogProc2,0);
				strcpy(G_IDCODE,TextENTERCODE);
			}
	if (direct_bool) ShowWindow(master_hwnd, SW_HIDE ); 
	if (!entercode) Start_server(G_IDCODE, G_CHARADRESS,G_CHARADRESS,G_PORT,Passwd,proxy,"PcHelpWare Connection",false);
	return true;
}

/////////////////////////////////////////////////////////////////////////////
////////////////////                      MAIN DIALOG       /////////////////
/////////////////////////////////////////////////////////////////////////////

HBITMAP
    DoGetBkGndBitmap(IN CONST UINT uBmpResId )
    {
        static HBITMAP hbmBkGnd = NULL;
        if (NULL == hbmBkGnd)
        {
            hbmBkGnd = (HBITMAP)LoadImage(NULL, "background.bmp", IMAGE_BITMAP, 0, 0,LR_LOADFROMFILE); 
            if (NULL == hbmBkGnd)
                hbmBkGnd = (HBITMAP)-1;
        }
        return (hbmBkGnd == (HBITMAP)-1)
            ? NULL : hbmBkGnd;
    }
/////////////////////////////////////////////////////////////////////////////
BOOL
    DoSDKEraseBkGnd(
        IN CONST HDC hDC,
        IN CONST COLORREF crBkGndFill
      )
    {
        HBITMAP hbmBkGnd = DoGetBkGndBitmap(IDB_LOGO64);
        if (hDC && hbmBkGnd)
        {
            RECT rc;
            if ((ERROR != GetClipBox(hDC, &rc)) && !IsRectEmpty(&rc))
            {
                HDC hdcMem = CreateCompatibleDC(hDC);
                if (hdcMem)
                {
                    HBRUSH hbrBkGnd = CreateSolidBrush(crBkGndFill);
                    if (hbrBkGnd)
                    {
                        HGDIOBJ hbrOld = SelectObject(hDC, hbrBkGnd);
                        if (hbrOld)
                        {
                            SIZE size = {
                                (rc.right-rc.left), (rc.bottom-rc.top)
                            };

                            if (PatBlt(hDC, rc.left, rc.top, size.cx, size.cy, PATCOPY))
                            {
                                HGDIOBJ hbmOld = SelectObject(hdcMem, hbmBkGnd);
                                if (hbmOld)
                                {
                                    StretchBlt(hDC, rc.left, rc.top, size.cx, size.cy,
                                        hdcMem, rc.left, rc.top,1,283, SRCCOPY);
                                    SelectObject(hdcMem, hbmOld);
                                }
                            }
                            SelectObject(hDC, hbrOld);
                        }
                        DeleteObject(hbrBkGnd);
                    }
                    DeleteDC(hdcMem);
                }
            }
			return TRUE;
        }
        return false;
    }
/////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK DialogProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
  switch(Message)
  {
	    	case WM_ERASEBKGND:
            {
				return DoSDKEraseBkGnd((HDC)wParam, RGB(128,128,128));
            }
			case WM_CTLCOLORSTATIC:
				{
				if (backgr_trans)
				{
				 SetBkColor((HDC) wParam, RGB(254,255,255));
				 SetBkMode((HDC) wParam, TRANSPARENT);
				 backgr_trans=0;
				 return false;
				}
				else
				{
				 SetBkMode((HDC) wParam, TRANSPARENT);
				 return (DWORD) GetStockObject(NULL_BRUSH);
				}
			}
			case WM_CTLCOLOREDIT:
			{
				SetBkColor((HDC) wParam, RGB(254,255,255));
				SetBkMode((HDC) wParam, TRANSPARENT);
				return false;//(DWORD) GetStockObject(NULL_BRUSH);
			}

		
			case WM_CLOSE:
				{
					 EndDialog(hWnd,0); // kill dialog
					 PostMessage(hWnd, WM_QUIT, 0, 0);
					 exit(0);
				}
				break;

			case WM_NOTIFY:
			{
				switch(LOWORD(wParam))
				{
					case IDC_LIST: 
					int flag=0;
					if(((LPNMHDR)lParam)->code == NM_DBLCLK)
					{
					  char Text[255]={0};  
					  char Temp[255]={0};
					  char Temp1[255]={0};
					  int iSlected=0;
					  int j=0;

					  

					  iSlected=SendMessage(hList,LVM_GETNEXTITEM,-1,LVNI_FOCUSED);
					  
					  if(iSlected==-1)
					  {
						MessageBox(hWnd,"No Items in ListView","Error",MB_OK|MB_ICONINFORMATION);
						break;
					  }

					  memset(&LvItem,0,sizeof(LvItem));
					  LvItem.mask=LVIF_TEXT;
					  LvItem.iSubItem=0;
					  LvItem.pszText=Text;
					  LvItem.cchTextMax=256;
					  LvItem.iItem=iSlected;
                  
					  SendMessage(hList,LVM_GETITEMTEXT, iSlected, (LPARAM)&LvItem);
					  
					  sprintf(Temp1,Text);
					  sprintf(Temp1,g_var[iSlected]);
					  strcpy(defaultCommandLine,Temp1);
					  if (Start_my_server())
					  EnableWindow(GetDlgItem( hWnd, IDC_BUTTON1),false);
					  //EndDialog(hWnd,0);		
					}

					if(((LPNMHDR)lParam)->code == NM_CLICK)
					{
						char Text[255]={0};  
					  char Temp[255]={0};
					  char Temp1[255]={0};
					  int iSlected=0;
					  int j=0;

					  iSlected=SendMessage(hList,LVM_GETNEXTITEM,-1,LVNI_FOCUSED);
					  
					  if(iSlected==-1)
					  {
						MessageBox(hWnd,"No Items in ListView","Error",MB_OK|MB_ICONINFORMATION);
						break;
					  }

					  memset(&LvItem,0,sizeof(LvItem));
					  LvItem.mask=LVIF_TEXT;
					  LvItem.iSubItem=0;
					  LvItem.pszText=Text;
					  LvItem.cchTextMax=256;
					  LvItem.iItem=iSlected;
                  
					  SendMessage(hList,LVM_GETITEMTEXT, iSlected, (LPARAM)&LvItem);
					  
					  sprintf(Temp1,Text);		
					  backgr_trans=1;
					  SetWindowText(GetDlgItem(hWnd,IDC_EDIT1),Text);
					  g_position=iSlected;
					}

					HWND hEdit;

					if(((LPNMHDR)lParam)->code == LVN_BEGINLABELEDIT)
					{
					  hEdit=ListView_GetEditControl(hList);
					}
					
					if(((LPNMHDR)lParam)->code == LVN_ENDLABELEDIT)
					{
						int iIndex;
						char text[255]="";
						iIndex=SendMessage(hList,LVM_GETNEXTITEM,-1,LVNI_FOCUSED);
						LvItem.iSubItem=0;
						LvItem.pszText=text;
						GetWindowText(hEdit, text, sizeof(text));
						SendMessage(hList,LVM_SETITEMTEXT,(WPARAM)iIndex,(LPARAM)&LvItem);
					}
					break;
				}
				return 0;
			}

			case WM_PAINT:
				{
					InvalidateRect(hWnd,NULL,true);
					return 0;
				}
				break;
			case WM_TIMER:
				{
					KillTimer(hWnd, 11);
					Start_my_server();
//					EndDialog(hWnd,0);
				}
				break;

			// This Window Message is the heart of the dialog  //
			//================================================//
			case WM_INITDIALOG:
				{
	//				GetIp();
					master_hwnd=hWnd;
					SetFocus(hWnd);
					hList=GetDlgItem(hWnd,IDC_LIST); // get the ID of the ListView
					SendMessage(hList,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT); // Set style

					// Here we put the info on the Coulom headers
					// this is not data, only name of each header we like
					memset(&LvCol,0,sizeof(LvCol)); // Reset Coluom
					LvCol.mask=LVCF_TEXT|LVCF_WIDTH|LVCF_SUBITEM; // Type of mask
					LvCol.cx=0x100;                                // width between each coloum
					LvCol.pszText="Select Helpdesk to connect to .......";                     // First Header
	// 				LvCol.cx=0x60;

					// Inserting Couloms as much as we want
					SendMessage(hList,LVM_INSERTCOLUMN,0,(LPARAM)&LvCol); // Insert/Show the coloum
					memset(&LvItem,0,sizeof(LvItem)); // Reset Item Struct
					
					//  Setting properties Of Items:

					LvItem.mask=LVIF_TEXT;   // Text Style
					LvItem.cchTextMax = 256; // Max size of test
                
					LvItem.iItem=0;          // choose item  
					LvItem.iSubItem=0;       // Put in first coluom
					LvItem.pszText="Item 0"; // Text to display (can be from a char variable) (Items)
	//				m_timer=SetTimer( hWnd, 1,  200, NULL);

					FILE *fid;
					bool done=false;
					char menustrings[1024];
					int iItem;
	//				char ItemText[160];
					if (GetModuleFileName(NULL, menustrings, 1024))
						{
							char* p = strrchr(menustrings, '\\');
							if (p == NULL) return 0;
							*p = '\0';
							strcat (menustrings,"\\helpdesk.txt");
						}
		
					int i=0;
					direct_bool=false;
					if ((fid = fopen(menustrings, "r"))!=NULL)
						{
							HBITMAP hImage = (HBITMAP)LoadImage(NULL, "logo.bmp", IMAGE_BITMAP, 0, 0,LR_LOADFROMFILE); 
							HWND logo=GetDlgItem(hWnd, IDC_LOGO);
							if (hImage) SendMessage(logo, STM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)(HANDLE)hImage);
							char myline[150];
							bWebpage=false;
							EnableWindow(GetDlgItem(hWnd,IDC_HELPWEB), false);
							ShowWindow( GetDlgItem(hWnd,IDC_HELPWEB), SW_HIDE ); 
							while( fgets( myline, sizeof(myline), fid ))
								{
									int j=0;
									if (strncmp(myline, "[END]", strlen("[END]")) == 0) {
									break;
									}
									if (strncmp(myline, "[BEGIN HOSTLIST]", strlen("[BEGIN HOSTLIST]")) == 0) {
									continue;
									}


									if (strncmp(myline, "[HOST]", strlen("[HOST]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(g_var_20[i],"");
									strncpy(g_var_20[i],myline,strlen(myline)-1);
									iItem=SendMessage(hList,LVM_GETITEMCOUNT,0,0);
									LvItem.iItem=iItem;            // choose item  
									LvItem.iSubItem=0;         // Put in first coluom
									LvItem.pszText=g_var_20[i];
									SendMessage(hList,LVM_INSERTITEM,0,(LPARAM)&LvItem);
									fgets( myline, sizeof(myline), fid );
									strcpy(g_var[i],"");
									strcpy(g_var[i],myline);
									i++;
									}

									if (strncmp(myline, "[TEXTTOP]", strlen("[TEXTTOP]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strncpy(TextTop,myline,strlen(myline)-1);
									TextTop[strlen(myline)-1]='\0';
									SendDlgItemMessage(hWnd,IDC_TEXTTOP, WM_SETTEXT, 0, (LONG)TextTop);
									}

									if (strncmp(myline, "[PASSWDMD5]", strlen("[PASSWDMD5]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strncpy(Passwd,myline,strlen(myline)-1);
									Passwd[strlen(myline)-1]='\0';
									}

									if (strncmp(myline, "[TEXTERROR]", strlen("[TEXTERROR]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strncpy(TextError,myline,strlen(myline)-1);
									TextError[strlen(myline)-1]='\0';
									}

									if (strncmp(myline, "[TEXTMIDDLE]", strlen("[TEXTMIDDLE]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strncpy(TextMiddle,myline,strlen(myline)-1);
									TextMiddle[strlen(myline)-1]='\0';
									SendDlgItemMessage(hWnd,IDC_TEXTMIDDLE, WM_SETTEXT, 0, (LONG)TextMiddle);
									}

									if (strncmp(myline, "[TEXTBOTTOM]", strlen("[TEXTBOTTOM]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strncpy(TextBottom,myline,strlen(myline)-1);
									TextBottom[strlen(myline)-1]='\0';
									SendDlgItemMessage(hWnd,IDC_TEXTBOTTOM, WM_SETTEXT, 0, (LONG)TextBottom);
									}

									if (strncmp(myline, "[TEXTRTOP]", strlen("[TEXTRTOP]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strncpy(TextRTop,myline,strlen(myline)-1);
									TextRTop[strlen(myline)-1]='\0';
									SendDlgItemMessage(hWnd,IDC_TEXTRICHTTOP, WM_SETTEXT, 0, (LONG)TextRTop);
									}

									if (strncmp(myline, "[TEXTRBOTTOM]", strlen("[TEXTRBOTTOM]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strncpy(TextRBottom,myline,strlen(myline)-1);
									TextRBottom[strlen(myline)-1]='\0';
									SendDlgItemMessage(hWnd,IDC_TEXTRIGHTBOTTOM, WM_SETTEXT, 0, (LONG)TextRBottom);
									}

									if (strncmp(myline, "[TEXTRMIDDLE]", strlen("[TEXTRMIDDLE]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strncpy(TextRMiddle,myline,strlen(myline)-1);
									TextRMiddle[strlen(myline)-1]='\0';
									SendDlgItemMessage(hWnd,IDC_TEXTRIGHTMIDDLE, WM_SETTEXT, 0, (LONG)TextRMiddle);
									}

									if (strncmp(myline, "[TEXTBUTTON]", strlen("[TEXTBUTTON]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									ZeroMemory(TextButton,sizeof(TextButton));
									strncpy(TextButton,myline,strlen(myline)-1);
									TextButton[strlen(myline)-1]='\0';
									ShowWindow( GetDlgItem(hWnd,IDC_HELPWEB), SW_SHOW ); 
									EnableWindow(GetDlgItem(hWnd,IDC_HELPWEB), true);
									SendDlgItemMessage(hWnd,IDC_HELPWEB, WM_SETTEXT, 0, (LONG)TextButton);
									}

									if (strncmp(myline, "[TEXTCONNECTBUTTON]", strlen("[TEXTCONNECTBUTTON]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									ZeroMemory(TextButton,sizeof(TextButton));
									strncpy(TextButton,myline,strlen(myline)-1);
									TextButton[strlen(myline)-1]='\0';
									ShowWindow( GetDlgItem(hWnd,IDC_BUTTON1), SW_SHOW ); 
									EnableWindow(GetDlgItem(hWnd,IDC_BUTTON1), true);
									SendDlgItemMessage(hWnd,IDC_BUTTON1, WM_SETTEXT, 0, (LONG)TextButton);
									}

									if (strncmp(myline, "[TEXTCLOSEBUTTON]", strlen("[TEXTCLOSEBUTTON]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(TextCButton,"");
									strncpy(TextCButton,myline,strlen(myline)-1);
									TextCButton[strlen(myline)-1]='\0';
									SendDlgItemMessage(hWnd,IDC_CLOSE, WM_SETTEXT, 0, (LONG)TextCButton);
									}

									if (strncmp(myline, "[TITLE]", strlen("[TITLE]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(TextTitle,myline);
									TextTitle[strlen(myline)-1]='\0';
									SetWindowText(hWnd,TextTitle);
									}

									if (strncmp(myline, "[WEBPAGE]", strlen("[WEBPAGE]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(Webpage,myline);
									bWebpage=true;
									}

									if (strncmp(myline, "[BALLOON1TITLE]", strlen("[BALLOON1TITLE]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(Balloon1Title,myline);
									Balloon1Title[strlen(myline)-1]='\0';
									}
									if (strncmp(myline, "[BALLOON1A]", strlen("[BALLOON1A]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(Balloon1A,myline);
									Balloon1A[strlen(myline)-1]='\0';
									}
									if (strncmp(myline, "[BALLOON1B]", strlen("[BALLOON1B]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(Balloon1B,myline);
									Balloon1B[strlen(myline)-1]='\0';
									}
									if (strncmp(myline, "[BALLOON1C]", strlen("[BALLOON1C]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(Balloon1C,myline);
									Balloon1C[strlen(myline)-1]='\0';
									}

									if (strncmp(myline, "[BALLOON2TITLE]", strlen("[BALLOON2TITLE]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(Balloon2Title,myline);
									Balloon2Title[strlen(myline)-1]='\0';
									}
									if (strncmp(myline, "[BALLOON2A]", strlen("[BALLOON2A]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(Balloon2A,myline);
									Balloon2A[strlen(myline)-1]='\0';
									}
									if (strncmp(myline, "[BALLOON2B]", strlen("[BALLOON2B]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(Balloon2B,myline);
									Balloon2B[strlen(myline)-1]='\0';
									}
									if (strncmp(myline, "[BALLOON2C]", strlen("[BALLOON2C]")) == 0) {
									fgets( myline, sizeof(myline), fid );
									strcpy(Balloon2C,myline);
									Balloon2C[strlen(myline)-1]='\0';
									}
									if (strncmp(myline, "[DIRECT]", strlen("[DIRECT]")) == 0) {
									direct_bool=true;
									}
									if (strncmp(myline, "[ENTERCODE]", strlen("[ENTERCODE]")) == 0) {
									entercode=true;
									fgets( myline, sizeof(myline), fid );
									strcpy(TextENTERCODE,myline);
									TextENTERCODE[strlen(myline)-1]='\0';
									}
									if (strncmp(myline, "[DEBUG]", strlen("[DEBUG]")) == 0) {

									}



									
									
									
								}
							fclose(fid);
						}				
					else EndDialog(hWnd,0);
					if (i==1 && direct_bool) 
					{
						strcpy(defaultCommandLine,g_var[0]);
						if (entercode) m_mytimerid = SetTimer(hWnd, 11, 20, NULL);
						else m_mytimerid = SetTimer(hWnd, 11, 20, NULL);
	//				    EndDialog(hWnd,0);
					}
					return TRUE; // Always True			
				}
				break;

			 // This Window Message will control the dialog  //
			//==============================================//
				case WM_COMMAND:
					switch (LOWORD(wParam))
						{
							case IDC_CLOSE:
								Stop_server();
								if (IsWindowEnabled( GetDlgItem(hWnd,IDC_BUTTON1))) 
								EndDialog(hWnd,0); // kill dialog
//								PostMessage(hWnd, WM_QUIT, 0, 0);
//								exit(0);
								waiting_for_quit=true;
								break;
							case IDC_BUTTON1:
								{
								if (!direct_bool)
								{
									char Text[255]={0}; 
									char Temp1[255]={0};
									SendDlgItemMessage(hWnd,IDC_EDIT1, WM_GETTEXT, 150, (LONG)Text);
									if (strlen(Text)==0) 
									{
										MessageBox(hWnd,TextError,"Error ",MB_ICONWARNING);
										break;
									}
									sprintf(Temp1,g_var[g_position]);
									strcpy(defaultCommandLine,Temp1);
								}
								if (Start_my_server())
								EnableWindow(GetDlgItem( hWnd, IDC_BUTTON1),false);
								//EndDialog(hWnd,0);	
								}
								break;
					case IDC_HELPWEB:
						if (bWebpage)ShellExecute(GetDesktopWindow(), "open", Webpage, "", 0, SW_SHOWNORMAL);
						break;
						}
					break;

				case WM_SYSCOMMAND:
					switch (LOWORD(wParam))
						{
							case WM_APP+1:
								backgr_trans=1;
								SendDlgItemMessage(hWnd,IDC_TEXTTOP, WM_SETTEXT, 0, (LONG)TextTop);
								backgr_trans=1;
								SendDlgItemMessage(hWnd,IDC_TEXTMIDDLE, WM_SETTEXT, 0, (LONG)TextMiddle);
								backgr_trans=1;
								SendDlgItemMessage(hWnd,IDC_TEXTBOTTOM, WM_SETTEXT, 0, (LONG)TextBottom);
								ShowWindow(hWnd, SW_SHOW); 
								EnableWindow(GetDlgItem( hWnd, IDC_BUTTON1),true);
								InvalidateRect(hWnd,NULL,true);
								if (waiting_for_quit) 
								{
									EndDialog(hWnd,0);
									break;
								}
								if (autoreconnect && ! entercode) SendMessage(hWnd,WM_COMMAND,IDC_BUTTON1,0);
								if (entercode) SendMessage(hWnd,WM_CLOSE,0,0);
							break;
							case WM_APP+2:
								backgr_trans=1;
								SendDlgItemMessage(hWnd,IDC_TEXTTOP, WM_SETTEXT, 0, (LONG)Balloon1Title);
								backgr_trans=1;
								SendDlgItemMessage(hWnd,IDC_TEXTMIDDLE, WM_SETTEXT, 0, (LONG)Balloon1A);
								backgr_trans=1;
								SendDlgItemMessage(hWnd,IDC_TEXTBOTTOM, WM_SETTEXT, 0, (LONG)Balloon1B);
								InvalidateRect(hWnd,NULL,true);
								break;
							case WM_APP+3:
								backgr_trans=1;
								SendDlgItemMessage(hWnd,IDC_TEXTTOP, WM_SETTEXT, 0, (LONG)Balloon2Title);
								backgr_trans=1;
								SendDlgItemMessage(hWnd,IDC_TEXTMIDDLE, WM_SETTEXT, 0, (LONG)Balloon2A);
								backgr_trans=1;
								SendDlgItemMessage(hWnd,IDC_TEXTBOTTOM, WM_SETTEXT, 0, (LONG)Balloon2B);
								InvalidateRect(hWnd,NULL,true);
								//Sleep(250);
								ShowWindow(hWnd, SW_HIDE); 
								break;
							case WM_APP+4:
								ShowWindow(hWnd, SW_SHOW); 
								break;
							case WM_APP+5:
								autoreconnect=false; 
								break;

						}
    
				default:return FALSE;
			}

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
/*unsigned int
Resolve(const char * address)
{
  unsigned int addr;

  // Try converting the address as IP
  addr = inet_addr(address);

  // Was it a valid IP address?
  if (addr == 0xffffffff)
    {
      // No, so get the actual IP address of the host name specified
      struct hostent *pHost;
      pHost = gethostbyname(address);
      if (pHost != NULL)
	  {
		  if (pHost->h_addr == NULL)
			  return 0;
		  addr = ((struct in_addr *)pHost->h_addr)->s_addr;
	  }
	  else
		  return 0;
    }

  // Return the resolved IP address as an integer
  return addr;
}*/

/////////////////////////////////////////////////////////////////////////////
//temp folder filetransfer
void EmtyDir()
{
     SHFILEOPSTRUCT sfo;
     ZeroMemory(&sfo, sizeof(SHFILEOPSTRUCT));
     sfo.wFunc = FO_DELETE;
     sfo.pFrom = "c:\\temp_phw\\*.*\0";
     sfo.fFlags = FOF_SILENT | FOF_NOCONFIRMATION | FOF_NOERRORUI ;
     SHFileOperation(&sfo);
}

/////////////////////////////////////////////////////////////////////////////
//////////////////////				ENTERCODE	DIALOG //////////////////////
/////////////////////////////////////////////////////////////////////////////
HBITMAP
DoGetBkGndBitmap3(IN CONST UINT uBmpResId )
    {
        static HBITMAP hbmBkGnd = NULL;
        if (NULL == hbmBkGnd)
        {
            hbmBkGnd = (HBITMAP)LoadImage(NULL, "enter.bmp", IMAGE_BITMAP, 0, 0,LR_LOADFROMFILE); 
			BITMAPINFOHEADER h2;
			h2.biSize=sizeof(h2);
			h2.biBitCount=0;
			// h2.biWidth=11; h2.biHeight=22; h2.biPlanes=1;
			HDC hxdc=CreateDC("DISPLAY",NULL,NULL,NULL);  
			GetDIBits(hxdc, hbmBkGnd, 0, 0, NULL, (BITMAPINFO*)&h2, DIB_RGB_COLORS);
			wdd=h2.biWidth; htd=h2.biHeight;
			DeleteDC(hxdc);
			//hbmBkGnd = (HBITMAP)LoadImage(
              //  GetModuleHandle(NULL), MAKEINTRESOURCE(uBmpResId),
                //    IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);

            if (NULL == hbmBkGnd)
                hbmBkGnd = (HBITMAP)-1;
        }
        return (hbmBkGnd == (HBITMAP)-1)
            ? NULL : hbmBkGnd;
    }
/////////////////////////////////////////////////////////////////////////////
BOOL
DoSDKEraseBkGnd3(
        IN CONST HDC hDC,
        IN CONST COLORREF crBkGndFill
      )
    {
        HBITMAP hbmBkGnd = DoGetBkGndBitmap3(IDB_LOGO64);
        if (hDC && hbmBkGnd)
        {
            RECT rc;
            if ((ERROR != GetClipBox(hDC, &rc)) && !IsRectEmpty(&rc))
            {
                HDC hdcMem = CreateCompatibleDC(hDC);
                if (hdcMem)
                {
                    HBRUSH hbrBkGnd = CreateSolidBrush(crBkGndFill);
                    if (hbrBkGnd)
                    {
                        HGDIOBJ hbrOld = SelectObject(hDC, hbrBkGnd);
                        if (hbrOld)
                        {
                            SIZE size = {
                                (rc.right-rc.left), (rc.bottom-rc.top)
                            };

                            if (PatBlt(hDC, rc.left, rc.top, size.cx, size.cy, PATCOPY))
                            {
                                HGDIOBJ hbmOld = SelectObject(hdcMem, hbmBkGnd);
                                if (hbmOld)
                                {
                                    StretchBlt(hDC, rc.left, rc.top, size.cx, size.cy,
                                        hdcMem, rc.left, rc.top,wdd,htd, SRCCOPY);
                                    SelectObject(hdcMem, hbmOld);
                                }
                            }
                            SelectObject(hDC, hbrOld);
                        }
                        DeleteObject(hbrBkGnd);
                    }
                    DeleteDC(hdcMem);
                }
            }
			return TRUE;
        }
        return false;
    }
/////////////////////////////////////////////////////////////////////////////
BOOL 
CALLBACK DialogProc2(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{

  switch(Message)
  {
	    	case WM_ERASEBKGND:
            {
                //DoSDKEraseBkGnd((HDC)wParam, RGB(255,0,0));
				return DoSDKEraseBkGnd3((HDC)wParam, RGB(128,128,128));
            }
			case WM_CTLCOLORSTATIC:
			//case WM_CTLCOLOREDIT:
			{
				//SetBkColor((HDC) wParam, RGB(128,255,255));
				SetBkMode((HDC) wParam, TRANSPARENT);
				return (DWORD) GetStockObject(NULL_BRUSH);
			}
        
         // This Window Message will close the dialog  //
		//============================================//
		case WM_CLOSE:
			{
			     EndDialog(hWnd,0); // kill dialog
				 PostMessage(hWnd, WM_QUIT, 0, 0);
				 exit(0);
			}
			break;
		case WM_PAINT:
			{
				InvalidateRect(hWnd,NULL,true);
				return 0;

			}
			break;
		

		// This Window Message is the heart of the dialog  //
		//================================================//
		case WM_INITDIALOG:
			{
//				GetIp();
				//SendMessage(GetDlgItem(hWnd, IDC_IDCODE), WM_NEXTDLGCTL, (WPARAM)hWnd, TRUE);
                SetFocus(GetDlgItem(hWnd, IDC_IDCODE));				
				SendDlgItemMessage(hWnd,IDC_STATICIDCODE, WM_SETTEXT, 0, (LONG)TextENTERCODE);
				typedef DWORD (WINAPI *PSLWA)(HWND, DWORD, BYTE, DWORD);

				PSLWA pSetLayeredWindowAttributes;
				HMODULE hDLL2 = LoadLibrary ("user32");
				pSetLayeredWindowAttributes = (PSLWA) GetProcAddress(hDLL2,"SetLayeredWindowAttributes");
				if (pSetLayeredWindowAttributes != NULL) {
				SetWindowLong (hWnd, GWL_EXSTYLE, GetWindowLong(hWnd, GWL_EXSTYLE) |WS_EX_LAYERED);
				pSetLayeredWindowAttributes (hWnd, RGB(247,255,255), 255, LWA_COLORKEY|LWA_ALPHA);
				}

				return false;
			}
								

     // This Window Message will control the dialog  //
	//==============================================//
        case WM_COMMAND:
			switch (LOWORD(wParam))
				{
					case IDCANCEL:
						EndDialog(hWnd,0); // kill dialog
						PostMessage(hWnd, WM_QUIT, 0, 0);
						exit(0);
						break;
					case IDOK:
						SendDlgItemMessage(hWnd,IDC_IDCODE, WM_GETTEXT, 150, (LONG)TextENTERCODE);
						strcpy(G_IDCODE,TextENTERCODE);
						Start_server(G_IDCODE, G_CHARADRESS,G_CHARADRESS,G_PORT,Passwd,proxy,"PcHelpWare Connection",false);
						EndDialog(hWnd,0);
						break;

					}
			break;
    
	    default:return FALSE;
    }

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
bool
ImportDLL_functions()
{
	hDLL = LoadLibrary ("1SCDLL.dll");
	if (!hDLL) return 0;
	Start_server = (Start_server_fn) GetProcAddress(hDLL,"Start_server");
	Stop_server = (Stop_server_fn) GetProcAddress(hDLL,"Stop_server");
	if (!Start_server || !Stop_server)
	{	
		// handle the error
		FreeLibrary(hDLL);
		return 0;		   
	}
	return 1;
}

void
Free_DLL_functions()
{
	if (hDLL)
		FreeLibrary(hDLL);
}
/////////////////////////////////////////////////////////////////////////////



int 
APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR     lpCmdLine,int       nCmdShow)
{
#ifdef CRASH_ENABLED
	LPVOID lpvState = Install(NULL,  "rudi.de.vos@skynet.be", "PcHelpware");
#endif
	if (!ImportDLL_functions())
	{
		MessageBox(NULL,"1SCDLL not found","Error ",MB_ICONWARNING);										
		return 0;
	}

	WSADATA wsaData;
	int result = WSAStartup(MAKEWORD(2, 0), &wsaData);	
	CreateDirectory("c:\\temp_phw", NULL);//temp folder filetransfer
	g_hinst=hInstance;
 	// TODO: Place code here.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwICC = ICC_LISTVIEW_CLASSES|ICC_INTERNET_CLASSES;
	InitCtrls.dwSize = sizeof(INITCOMMONCONTROLSEX);
	BOOL bRet = InitCommonControlsEx(&InitCtrls);
	WNDCLASS wc = {0}; 
	wc.style = CS_BYTEALIGNWINDOW|CS_SAVEBITS|CS_DBLCLKS; 
	wc.lpfnWndProc = DefDlgProc; 
	wc.cbWndExtra = DLGWINDOWEXTRA; 
	wc.hInstance = hInstance; 
//	wc.hIcon = LoadIcon(IDI_ICON1); 
	wc.hCursor = ::LoadCursor(NULL, IDC_ARROW); 
	wc.hbrBackground = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)); 
	wc.lpszClassName = "PcHelpWare Connection"; 
	ATOM cls = RegisterClass(&wc); 

	DialogBoxParam(hInstance, MAKEINTRESOURCE(IDC_DIALOG), NULL, (DLGPROC)DialogProc,0);
	EmtyDir();

	WSACleanup();
	Free_DLL_functions();
	return 0;
}
